﻿/* DNN TurboDBConfig Version 0.9.5 (2014-10-08)
   ================================================================================
   (c) Sebastian Leupold, dnnWerk/gamma concept mbH 2014

   Run this Script to configure your database for optimal performance with DNN 7.
      
   == Please make sure to use latest version from http://dnnscript.codeplex.com ===
   
   Instructions:
   =============
   - Install by running as script from SQL item in Host menu inside DNN or run in 
     SQL Server Management Studio.

   - Make sure that the currently used account is member of dbOwner database role.
   
   License and Disclaimer:
   =======================
   Published under Microsoft Open Source Reciprocal License (Ms-RL). For details, 
   please read http://dnnscript.codeplex.com/license.
   Feel free to use this script as you need, but there is no warranty or liability 
   for any damage or effort, eventually been caused.

   Please report issues at https://dnnscript.codeplex.com/WorkItem/Create
   ================================================================================
*/

DECLARE @dbVersion 						Int;
DECLARE @ServerVersion 					Int;
DECLARE @dbName 						nVarChar(100);
DECLARE @is_auto_create_stats_on 		Bit;
DECLARE @is_auto_update_stats_on 		Bit;
DECLARE @is_auto_update_stats_async_on  Bit;

	SELECT 
		@dbName                  		= Name,
		@dbVersion               		= compatibility_level, 
		@is_auto_update_stats_on 		= is_auto_update_stats_on,
		@is_auto_create_stats_on 	    = is_auto_create_stats_on,
		@is_auto_update_stats_async_on  = is_auto_update_stats_async_on
	FROM sys.databases 
	WHERE name = db_name();
	
	SET @ServerVersion = Convert(Int, left(Convert(nVarChar, SERVERPROPERTY('ProductVersion')), 2) * 10);
	DECLARE @VersionStr nVarChar(4)  = CAST(@ServerVersion AS VarChar(4));

	IF @dbVersion < @ServerVersion        Exec ('ALTER DATABASE [' + @dbName + '] SET COMPATIBILITY_LEVEL = ' + @VersionStr);
	IF @is_auto_create_stats_on       = 0 Exec ('ALTER DATABASE [' + @dbName + '] SET AUTO_CREATE_STATISTICS       ON');
	IF @is_auto_update_stats_on       = 0 Exec ('ALTER DATABASE [' + @dbName + '] SET AUTO_UPDATE_STATISTICS       ON');
	IF @is_auto_update_stats_async_on = 0 Exec ('ALTER DATABASE [' + @dbName + '] SET AUTO_UPDATE_STATISTICS_ASYNC ON');
	Exec ('ALTER DATABASE [' + @dbName + '] SET ANSI_Null_DEFAULT       OFF');
	Exec ('ALTER DATABASE [' + @dbName + '] SET ANSI_NullS              OFF');
	Exec ('ALTER DATABASE [' + @dbName + '] SET ANSI_PADDING            OFF');
	Exec ('ALTER DATABASE [' + @dbName + '] SET ANSI_WARNINGS           OFF');
	Exec ('ALTER DATABASE [' + @dbName + '] SET ARITHABORT              OFF');
	Exec ('ALTER DATABASE [' + @dbName + '] SET CONCAT_Null_YIELDS_Null OFF');
	Exec ('ALTER DATABASE [' + @dbName + '] SET QUOTED_IDENTIFIER       OFF');
	Exec ('ALTER DATABASE [' + @dbName + '] SET NUMERIC_ROUNDABORT      OFF');
	Exec ('ALTER DATABASE [' + @dbName + '] SET RECURSIVE_TRIGGERS      OFF');
GO
