/* DNN TurboUnSchema Version 0.9.5 (2014-10-08)
   ================================================================================
   (c) Sebastian Leupold, dnnWerk/gamma concept mbH 2014

   UNDO Script for performance tuning of DNN Platform V. 7.1.2 - 7.3.3
   
   Apply this script before performing any DNN platform upgrades 
   or newer versions of TurboDNN and TurboSchema.
   
   == Please make sure to use latest version from http://dnnscript.codeplex.com ===
   
   Instructions:
   =============
   - Install by running as script from SQL item in Host menu inside DNN or run in 
     SQL Server Management Studio, after replacing placeholders {databaseOwner} and 
	 {objectQualifier} with corresponding values of your web.config file.

   License and Disclaimer:
   =======================
   Published under Microsoft Open Source Reciprocal License (Ms-RL). For details, 
   please read http://dnnscript.codeplex.com/license.
   Feel free to use this script as you need, but there is no warranty or liability 
   for any damage or effort, eventually been caused.

   Please report issues at https://dnnscript.codeplex.com/WorkItem/Create
   ================================================================================
*/

-- -------------------------- Instrumentation -------------------------

IF EXISTS (SELECT * FROM sys.sysobjects WHERE id = object_id(N'{databaseOwner}[{objectQualifier}sys_currentDNNVersion]') AND Type = 'FN')
	DROP FUNCTION {databaseOwner}[{objectQualifier}sys_currentDNNVersion]
GO

CREATE FUNCTION {databaseOwner}[{objectQualifier}sys_currentDNNVersion]()
	RETURNS Int
AS	
BEGIN
	DECLARE @Vers Int
	SELECT Top(1) @Vers = Major * 10000 + Minor * 100 + Build FROM {databaseOwner}[{objectQualifier}Version] ORDER BY CreatedDate DESC;
	RETURN @Vers
END
GO

-- ----------------------- Drop all procedures that rely on schema-bound views and functions ------------------------
IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'{databaseOwner}[{objectQualifier}Journal_TypeFilters_List]') AND type in (N'P', N'PC'))
	DROP PROCEDURE {databaseOwner}[{objectQualifier}Journal_TypeFilters_List]
GO

IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'{databaseOwner}[{objectQualifier}Journal_Comment_Get]') AND type in (N'P', N'PC'))
	DROP PROCEDURE {databaseOwner}[{objectQualifier}Journal_Comment_Get]
GO

IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'{databaseOwner}[{objectQualifier}Journal_Comment_ListByJournalIds]') AND type in (N'P', N'PC'))
	DROP PROCEDURE {databaseOwner}[{objectQualifier}Journal_Comment_ListByJournalIds]
GO

IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'{databaseOwner}[{objectQualifier}Journal_Comment_List]') AND type in (N'P', N'PC'))
	DROP PROCEDURE {databaseOwner}[{objectQualifier}Journal_Comment_List]
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'{databaseOwner}[{objectQualifier}Journal_ListForProfile]') AND OBJECTPROPERTY(id, N'IsPROCEDURE') = 1)
	DROP PROCEDURE {databaseOwner}[{objectQualifier}Journal_ListForProfile]
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'{databaseOwner}[{objectQualifier}Journal_ListForSummary]') AND OBJECTPROPERTY(id, N'IsPROCEDURE') = 1)
	DROP PROCEDURE {databaseOwner}[{objectQualifier}Journal_ListForSummary]
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'{databaseOwner}[{objectQualifier}Journal_ListForGroup]') AND OBJECTPROPERTY(id, N'IsPROCEDURE') = 1)
	DROP PROCEDURE {databaseOwner}[{objectQualifier}Journal_ListForGroup]
GO

IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'{databaseOwner}[{objectQualifier}Journal_Get]') AND OBJECTPROPERTY(id, N'IsPROCEDURE') = 1)
  DROP PROCEDURE {databaseOwner}[{objectQualifier}Journal_Get]
GO
IF EXISTS (SELECT * FROM dbo.sysobjects WHERE id = object_id(N'{databaseOwner}[{objectQualifier}Journal_GetStatsForGroup]') AND OBJECTPROPERTY(id, N'IsPROCEDURE') = 1)
  DROP PROCEDURE {databaseOwner}[{objectQualifier}Journal_GetStatsForGroup]
GO

IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'{databaseOwner}[{objectQualifier}GetUserRolesByUsername]') AND type in (N'P', N'PC'))
    DROP PROCEDURE {databaseOwner}[{objectQualifier}GetUserRolesByUsername]
GO

IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'{databaseOwner}[{objectQualifier}GetUserCountByPortal]') AND type in (N'P', N'PC'))
    DROP PROCEDURE {databaseOwner}[{objectQualifier}GetUserCountByPortal]
GO

IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'{databaseOwner}[{objectQualifier}GetUserRoles]') AND type in (N'P', N'PC'))
    DROP PROCEDURE {databaseOwner}[{objectQualifier}GetUserRoles]
GO

IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'{databaseOwner}[{objectQualifier}GetUserRole]') AND type in (N'P', N'PC'))
    DROP PROCEDURE {databaseOwner}[{objectQualifier}GetUserRole]
GO

IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'{databaseOwner}[{objectQualifier}GetRoles]') AND type in (N'P', N'PC'))
    DROP PROCEDURE {databaseOwner}[{objectQualifier}GetRoles]
GO

IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'{databaseOwner}[{objectQualifier}GetPortalRoles]') AND type in (N'P', N'PC'))
    DROP PROCEDURE {databaseOwner}[{objectQualifier}GetPortalRoles]
GO

IF EXISTS (SELECT * FROM sys.objects WHERE object_id = object_id(N'{databaseOwner}[{objectQualifier}GetSearchResults]') AND type in (N'P', N'PC'))
	DROP PROCEDURE {databaseOwner}[{objectQualifier}GetSearchResults]
GO

IF EXISTS (SELECT * FROM sys.objects WHERE object_id = object_id(N'{databaseOwner}[{objectQualifier}GetSearchItems]') AND type in (N'P', N'PC'))
	DROP PROCEDURE {databaseOwner}[{objectQualifier}GetSearchItems]
GO

IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'{databaseOwner}[{objectQualifier}GetRolesByUser]') AND type in (N'P', N'PC'))
    DROP PROCEDURE {databaseOwner}[{objectQualifier}GetRolesByUser]
GO

IF EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'{databaseOwner}[{objectQualifier}GetExtensionUrlProviders]') AND type in (N'P', N'PC'))
	DROP PROCEDURE {databaseOwner}[{objectQualifier}GetExtensionUrlProviders]
GO

IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'{databaseOwner}[{objectQualifier}GetModulePackagesInUse]') AND Type IN (N'P', N'PC'))
    DROP PROCEDURE {databaseOwner}[{objectQualifier}GetModulePackagesInUse]
GO

IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'{databaseOwner}[{objectQualifier}GetPortalDesktopModules]') AND type in (N'P', N'PC'))
    DROP PROCEDURE {databaseOwner}[{objectQualifier}GetPortalDesktopModules]
GO

IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'{databaseOwner}[{objectQualifier}GetTabSettings]') AND type in (N'P', N'PC'))
    DROP PROCEDURE {databaseOwner}[{objectQualifier}GetTabSettings]
GO

IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'{databaseOwner}[{objectQualifier}GetTabModuleSettingsByTab]') AND type in (N'P', N'PC'))
    DROP PROCEDURE {databaseOwner}[{objectQualifier}GetTabModuleSettingsByTab]
GO

IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'{databaseOwner}[{objectQualifier}GetModulePermissionsByTabID]') AND type in (N'P', N'PC'))
    DROP PROCEDURE {databaseOwner}[{objectQualifier}GetModulePermissionsByTabID]
GO

IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'{databaseOwner}[{objectQualifier}GetModules]') AND type in (N'P', N'PC'))
    DROP PROCEDURE {databaseOwner}[{objectQualifier}GetModules]
GO

IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'{databaseOwner}[{objectQualifier}GetModule]') AND type in (N'P', N'PC'))
    DROP PROCEDURE {databaseOwner}[{objectQualifier}GetModule]
GO

IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'{databaseOwner}[{objectQualifier}GetFile]') AND type in (N'P', N'PC'))
    DROP PROCEDURE {databaseOwner}[{objectQualifier}GetFile]
GO

IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'{databaseOwner}[{objectQualifier}GetFileById]') AND type in (N'P', N'PC'))
    DROP PROCEDURE {databaseOwner}[{objectQualifier}GetFileById]
GO

IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'{databaseOwner}[{objectQualifier}GetFiles]') AND type in (N'P', N'PC'))
    DROP PROCEDURE {databaseOwner}[{objectQualifier}GetFiles]
GO

IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'{databaseOwner}[{objectQualifier}CoreMessaging_GetMessageThread]') AND type in (N'P', N'PC'))
	DROP PROCEDURE {databaseOwner}[{objectQualifier}CoreMessaging_GetMessageThread]
GO

IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'{databaseOwner}[{objectQualifier}CoreMessaging_GetMessageConversations]') AND type in (N'P', N'PC'))
	DROP PROCEDURE {databaseOwner}[{objectQualifier}CoreMessaging_GetMessageConversations]
GO

IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'{databaseOwner}[{objectQualifier}CoreMessaging_GetArchiveBox]') AND type in (N'P', N'PC'))
	DROP PROCEDURE {databaseOwner}[{objectQualifier}CoreMessaging_GetArchiveBox]
GO

IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'{databaseOwner}[{objectQualifier}CoreMessaging_CreateMessageRecipientsForRole]') AND type in (N'P', N'PC'))
    DROP PROCEDURE {databaseOwner}[{objectQualifier}CoreMessaging_CreateMessageRecipientsForRole]
GO

IF EXISTS (SELECT * FROM sys.objects WHERE object_id = object_id(N'{databaseOwner}[{objectQualifier}CoreMessaging_CheckReplyHasRecipients]') AND type in (N'P', N'PC'))
	DROP PROCEDURE {databaseOwner}[{objectQualifier}CoreMessaging_CheckReplyHasRecipients]
GO

IF EXISTS (SELECT * FROM sys.objects WHERE object_id = object_id(N'{databaseOwner}[{objectQualifier}CoreMessaging_CountNewThreads]') AND type in (N'P', N'PC'))
	DROP PROCEDURE {databaseOwner}[{objectQualifier}CoreMessaging_CountNewThreads]
GO
-- --------------------------- Drop View Based Functions ---------------------

IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'{databaseOwner}[{objectQualifier}Journal_ValidJournalTypesForModule]') AND type in (N'FN', N'IF', N'TF', N'FS', N'FT'))
	DROP FUNCTION {databaseOwner}[{objectQualifier}Journal_ValidJournalTypesForModule]
GO

IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'{databaseOwner}[{objectQualifier}Journal_User_Permissions]') AND type in (N'FN', N'IF', N'TF', N'FS', N'FT'))
	DROP FUNCTION {databaseOwner}[{objectQualifier}Journal_User_Permissions]
GO

IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'{databaseOwner}[{objectQualifier}Journal_PermittedJournalIDs]') AND type in (N'FN', N'IF', N'TF', N'FS', N'FT'))
	DROP FUNCTION {databaseOwner}[{objectQualifier}Journal_PermittedJournalIDs];
GO

IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'{databaseOwner}[{objectQualifier}MasterPortalId]') AND type = N'FN')
    DROP FUNCTION {databaseOwner}[{objectQualifier}MasterPortalId]
GO

IF EXISTS (SELECT * FROM Sys.objects WHERE object_id = OBJECT_ID(N'{objectQualifier}FitsExtendedPropertyPermission') AND TYPE = N'FN')
	DROP FUNCTION {databaseOwner}[{objectQualifier}FitsExtendedPropertyPermission]
GO

IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'{databaseOwner}[{objectQualifier}GetUsersByPropertyName]') AND type in (N'FN', N'TF', N'IF'))
	DROP FUNCTION {databaseOwner}[{objectQualifier}GetUsersByPropertyName]
GO


-- --------------------------- Drop Views ------------------------------------
IF EXISTS (select * from sys.objects where object_id = object_id(N'{databaseOwner}[{objectQualifier}vw_JournalComments]') AND type in (N'V'))
    DROP VIEW {databaseOwner}[{objectQualifier}vw_JournalComments]
GO

IF EXISTS (select * from sys.objects where object_id = object_id(N'{databaseOwner}[{objectQualifier}vw_JournalTypeFilters]') AND type in (N'V'))
    DROP VIEW {databaseOwner}[{objectQualifier}vw_JournalTypeFilters]
GO

IF EXISTS (select * from sys.objects where object_id = object_id(N'{databaseOwner}[{objectQualifier}vw_JournalSecurity]') AND type in (N'V'))
    DROP VIEW {databaseOwner}[{objectQualifier}vw_JournalSecurity]
GO

IF EXISTS (select * from sys.objects where object_id = object_id(N'{databaseOwner}[{objectQualifier}vw_JournalItems]') AND type in (N'V'))
    DROP VIEW {databaseOwner}[{objectQualifier}vw_JournalItems]
GO

IF EXISTS (select * from sys.objects where object_id = object_id(N'{databaseOwner}[{objectQualifier}vw_JournalBase]') AND type in (N'V'))
    DROP VIEW {databaseOwner}[{objectQualifier}vw_JournalBase]
GO

IF EXISTS (SELECT * FROM sys.objects WHERE object_id = object_id(N'{databaseOwner}[{objectQualifier}vw_MessagesForDispatch]') AND type in (N'V'))
	DROP VIEW {databaseOwner}[{objectQualifier}vw_MessagesForDispatch]
GO

IF EXISTS (SELECT * FROM sys.objects WHERE object_id = object_id(N'{databaseOwner}[{objectQualifier}vw_CoreMessaging_Recipients]') AND type in (N'V'))
	DROP VIEW {databaseOwner}[{objectQualifier}vw_CoreMessaging_Recipients]
GO

IF EXISTS (SELECT * FROM sys.objects WHERE object_id = object_id(N'{databaseOwner}[{objectQualifier}vw_CoreMessaging_Messages]') AND type in (N'V'))
	DROP VIEW {databaseOwner}[{objectQualifier}vw_CoreMessaging_Messages]
GO

IF EXISTS (select * from Sys.objects where object_id = object_id(N'{databaseOwner}[{objectQualifier}vw_ContentWorkflowStatePermissions]') and type in (N'V'))
    DROP VIEW {databaseOwner}[{objectQualifier}vw_ContentWorkflowStatePermissions]
GO

IF EXISTS (select * from Sys.objects where object_id = object_id(N'{databaseOwner}[{objectQualifier}vw_Lists]') and type in (N'V'))
	DROP VIEW {databaseOwner}[{objectQualifier}vw_Lists]
GO

IF EXISTS (SELECT * FROM Sys.objects WHERE object_id = object_id(N'{databaseOwner}[{objectQualifier}vw_RelatedUsers]')AND type in (N'V'))
	DROP VIEW {databaseOwner}[{objectQualifier}vw_RelatedUsers]
GO

IF EXISTS (SELECT * FROM Sys.objects WHERE object_id = object_id(N'{databaseOwner}[{objectQualifier}vw_RelationBase]')AND type in (N'V'))
	DROP VIEW {databaseOwner}[{objectQualifier}vw_RelationBase]
GO

IF EXISTS (select * from sys.objects where object_id = object_id(N'{databaseOwner}[{objectQualifier}vw_ExtensionUrlProviders]') AND type in (N'V'))
    DROP VIEW {databaseOwner}[{objectQualifier}vw_ExtensionUrlProviders]
GO

IF EXISTS (select * from sys.objects where object_id = object_id(N'{databaseOwner}[{objectQualifier}vw_SearchItems]') AND type in (N'V'))
    DROP VIEW {databaseOwner}[{objectQualifier}vw_SearchItems]
GO

IF EXISTS (select * from sys.objects where object_id = object_id(N'{databaseOwner}[{objectQualifier}vw_SearchItemBase]') AND type in (N'V'))
    DROP VIEW {databaseOwner}[{objectQualifier}vw_SearchItemBase]
GO

IF EXISTS (SELECT * FROM Sys.objects WHERE object_id = object_id(N'{databaseOwner}[{objectQualifier}vw_DesktopModulePermissions]') AND type in (N'V'))
	DROP VIEW {databaseOwner}[{objectQualifier}vw_DesktopModulePermissions]
GO

IF EXISTS (SELECT * FROM Sys.objects WHERE object_id = object_id(N'{databaseOwner}[{objectQualifier}vw_FolderPermissions]') AND type in (N'V'))
	DROP VIEW {databaseOwner}[{objectQualifier}vw_FolderPermissions]
GO

IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'{databaseOwner}[{objectQualifier}vw_ModulePermissionTabs]') AND type in (N'V'))
    DROP VIEW {databaseOwner}[{objectQualifier}vw_ModulePermissionTabs]
GO

IF EXISTS (SELECT * FROM Sys.objects WHERE object_id = object_id(N'{databaseOwner}[{objectQualifier}vw_ModulePermissions]') AND type in (N'V'))
	DROP VIEW {databaseOwner}[{objectQualifier}vw_ModulePermissions]
GO

IF EXISTS (SELECT * FROM Sys.objects WHERE object_id = object_id(N'{databaseOwner}[{objectQualifier}vw_TabPermissions]') AND type in (N'V'))
	DROP VIEW {databaseOwner}[{objectQualifier}vw_TabPermissions]
GO

IF EXISTS (SELECT * FROM Sys.objects WHERE object_id = object_id(N'{databaseOwner}[{objectQualifier}vw_TabPermissionBase]') AND type in (N'V'))
	DROP VIEW {databaseOwner}[{objectQualifier}vw_TabPermissionBase]
GO

IF EXISTS (SELECT * FROM Sys.objects WHERE object_id = object_id(N'{databaseOwner}[{objectQualifier}vw_ModulePermissionBase]') AND type in (N'V'))
	DROP VIEW {databaseOwner}[{objectQualifier}vw_ModulePermissionBase]
GO

IF EXISTS (SELECT * FROM Sys.objects WHERE object_id = object_id(N'{databaseOwner}[{objectQualifier}vw_FolderPermissionBase]') AND type in (N'V'))
	DROP VIEW {databaseOwner}[{objectQualifier}vw_FolderPermissionBase]
GO

IF EXISTS (SELECT * FROM Sys.objects WHERE object_id = object_id(N'{databaseOwner}[{objectQualifier}vw_DesktopModulePermissionBase]') AND type in (N'V'))
	DROP VIEW {databaseOwner}[{objectQualifier}vw_DesktopModulePermissionBase]
GO

IF EXISTS (select * from sys.objects WHERE object_id = object_id(N'{databaseOwner}[{objectQualifier}vw_PortalDesktopModules]') AND type in (N'V'))
    DROP VIEW {databaseOwner}[{objectQualifier}vw_PortalDesktopModules]
GO

IF EXISTS (SELECT * FROM Sys.Views WHERE (name = N'{objectQualifier}vw_TabSettings'))
	DROP VIEW {databaseOwner}[{objectQualifier}vw_TabSettings]
GO

IF EXISTS (SELECT * FROM Sys.Views WHERE (name = N'{objectQualifier}vw_TabModuleSettings'))
	DROP VIEW {databaseOwner}[{objectQualifier}vw_TabModuleSettings]
GO

IF EXISTS (SELECT * FROM Sys.objects WHERE object_id = object_id(N'{databaseOwner}[{objectQualifier}vw_TabModules]') AND type in (N'V'))
	DROP VIEW {databaseOwner}[{objectQualifier}vw_TabModules]
GO

IF EXISTS (SELECT * FROM Sys.Views WHERE (name = N'{objectQualifier}vw_ModuleSettings'))
	DROP VIEW {databaseOwner}[{objectQualifier}vw_ModuleSettings]
GO

IF EXISTS (select * from sys.objects WHERE object_id = object_id(N'{databaseOwner}[{objectQualifier}vw_ModulesOnTabs]') AND type in (N'V'))
    DROP VIEW {databaseOwner}[{objectQualifier}vw_ModulesOnTabs]
GO

IF EXISTS (select * from sys.objects WHERE object_id = object_id(N'{databaseOwner}[{objectQualifier}vw_Modules]') AND type in (N'V'))
    DROP VIEW {databaseOwner}[{objectQualifier}vw_Modules]
GO

IF EXISTS (select * from sys.objects WHERE object_id = object_id(N'{databaseOwner}[{objectQualifier}vw_ModuleTabs]') AND type in (N'V'))
    DROP VIEW {databaseOwner}[{objectQualifier}vw_ModuleTabs]
GO

IF EXISTS (select * from sys.objects WHERE object_id = object_id(N'{databaseOwner}[{objectQualifier}vw_ModuleBase]') AND type in (N'V'))
    DROP VIEW {databaseOwner}[{objectQualifier}vw_ModuleBase]
GO

IF EXISTS (select * from sys.objects WHERE object_id = OBJECT_ID(N'{databaseOwner}[{objectQualifier}vw_Tabs]') AND type in (N'V'))
    DROP VIEW {databaseOwner}[{objectQualifier}vw_Tabs]
GO

IF EXISTS (select * from sys.objects WHERE object_id = object_id(N'{databaseOwner}[{objectQualifier}vw_Profile]') AND type in (N'V'))
    DROP VIEW {databaseOwner}[{objectQualifier}vw_Profile]
GO

IF EXISTS (select * from sys.objects WHERE object_id = object_id(N'{databaseOwner}[{objectQualifier}vw_ProfileBase]') AND type in (N'V'))
    DROP VIEW {databaseOwner}[{objectQualifier}vw_ProfileBase]
GO

IF EXISTS (select * from sys.objects WHERE object_id = object_id(N'{databaseOwner}[{objectQualifier}vw_ProfileDataTypes]') AND type in (N'V'))
    DROP VIEW {databaseOwner}[{objectQualifier}vw_ProfileDataTypes]
GO

IF EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'{databaseOwner}[{objectQualifier}vw_UserRoles]') AND type in (N'V'))
	DROP VIEW {databaseOwner}[{objectQualifier}vw_UserRoles]
GO

IF EXISTS (SELECT * FROM Sys.objects WHERE object_id = OBJECT_ID(N'{databaseOwner}[{objectQualifier}vw_Users]') AND type in (N'V'))
	DROP VIEW {databaseOwner}[{objectQualifier}vw_Users]
GO

IF EXISTS (SELECT * FROM Sys.objects WHERE object_id = object_id(N'{databaseOwner}[{objectQualifier}vw_PortalsDefaultLanguage]') AND type in (N'V'))
	DROP VIEW {databaseOwner}[{objectQualifier}vw_PortalsDefaultLanguage]
GO

IF EXISTS (select * from sys.objects WHERE object_id = object_id(N'{databaseOwner}[{objectQualifier}vw_MasterPortals]') AND type in (N'V'))
    DROP VIEW {databaseOwner}[{objectQualifier}vw_MasterPortals]
GO

IF EXISTS (select * from sys.objects WHERE object_id = object_id(N'{databaseOwner}[{objectQualifier}vw_Portals]') AND type in (N'V'))
    DROP VIEW {databaseOwner}[{objectQualifier}vw_Portals]
GO

IF EXISTS (select * from sys.objects WHERE object_id = object_id(N'{databaseOwner}[{objectQualifier}vw_PortalBase]') AND type in (N'V'))
    DROP VIEW {databaseOwner}[{objectQualifier}vw_PortalBase]
GO

IF EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'{databaseOwner}[{objectQualifier}vw_PublishedFiles]') AND type in (N'V'))
	DROP VIEW {databaseOwner}[{objectQualifier}vw_PublishedFiles]
GO

IF EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'{databaseOwner}[{objectQualifier}vw_Files]') AND type in (N'V'))
	DROP VIEW {databaseOwner}[{objectQualifier}vw_Files]
GO


-- --------------------------- Drop Table Based Functions --------------------

IF EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'{databaseOwner}[{objectQualifier}FileSize]') AND type in (N'FN', N'IF', N'TF', N'FS', N'FT'))
	DROP FUNCTION {databaseOwner}[{objectQualifier}FileSize]
GO

IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'{databaseOwner}[{objectQualifier}FilePath]') AND type in (N'FN', N'IF', N'TF', N'FS', N'FT'))
    DROP FUNCTION {databaseOwner}[{objectQualifier}FilePath]
GO

IF EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'{databaseOwner}[{objectQualifier}vw_FilePaths]') AND type in (N'V'))
	DROP VIEW {databaseOwner}[{objectQualifier}vw_FilePaths]
GO

IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'{databaseOwner}[{objectQualifier}UserIsInRole]') AND type = N'FN')
    DROP FUNCTION {databaseOwner}[{objectQualifier}UserIsInRole]
GO

IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'{databaseOwner}[{objectQualifier}UserName]') AND type = N'FN')
    DROP FUNCTION {databaseOwner}[{objectQualifier}UserName]
GO

IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'{databaseOwner}[{objectQualifier}UserEmail]') AND type = N'FN')
    DROP FUNCTION {databaseOwner}[{objectQualifier}UserEmail]
GO

IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'{databaseOwner}[{objectQualifier}UserDisplayName]') AND type = N'FN')
    DROP FUNCTION {databaseOwner}[{objectQualifier}UserDisplayName]
GO

IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'{databaseOwner}[{objectQualifier}SuperuserTabID]') AND type = N'FN')
    DROP FUNCTION {databaseOwner}[{objectQualifier}SuperuserTabID]
GO

IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'{databaseOwner}[{objectQualifier}RoleName]') AND type = N'FN')
    DROP FUNCTION {databaseOwner}[{objectQualifier}RoleName]
GO

IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'{databaseOwner}[{objectQualifier}HasChildTab]') AND type = N'FN')
    DROP FUNCTION {databaseOwner}[{objectQualifier}HasChildTab]
GO

IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'{databaseOwner}[{objectQualifier}GetProfilePropertyDefinitionID]') AND type = N'FN')
    DROP FUNCTION {databaseOwner}[{objectQualifier}GetProfilePropertyDefinitionID]
GO

IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'{databaseOwner}[{objectQualifier}GetProfileFieldSql]') AND type = N'FN')
    DROP FUNCTION {databaseOwner}[{objectQualifier}GetProfileFieldSql]
GO

IF EXISTS (SELECT * FROM sys.objects WHERE object_id = object_id(N'{databaseOwner}[{objectQualifier}GetListParentKey]') AND type = N'FN')
    DROP FUNCTION {databaseOwner}[{objectQualifier}GetListParentKey]
GO

IF EXISTS (SELECT * FROM Sys.objects WHERE object_id = object_id(N'{databaseOwner}[{objectQualifier}AdministratorRoleId]') AND TYPE = 'FN')
	DROP FUNCTION {databaseOwner}[{objectQualifier}AdministratorRoleId]
GO

-- --------------------------- Drop calculated column (deprecated) -----------

IF EXISTS (SELECT * FROM sys.columns WHERE object_id = OBJECT_ID(N'{databaseOwner}[{objectQualifier}Files]') AND name ='Folder')
	ALTER TABLE {databaseOwner}[{objectQualifier}Files] DROP COLUMN Folder
GO

IF EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'{databaseOwner}[{objectQualifier}GetFileFolderFunc]') AND type in (N'FN', N'IF', N'TF', N'FS', N'FT'))
	DROP FUNCTION {databaseOwner}[{objectQualifier}GetFileFolderFunc]
GO


-- --------------------------- Bind calculated column (deprecated) -----------

CREATE FUNCTION {databaseOwner}[{objectQualifier}GetFileFolderFunc]
	(@FolderD  Int         )	-- Not Null!
	RETURNS    nVarChar(246) 	-- FolderPath associated with FolderID
	
AS
BEGIN
    DECLARE @folderPath nVarChar(246)
    SELECT @folderPath = FolderPath FROM {databaseOwner}[{objectQualifier}Folders] WHERE FolderID = @FolderD
	RETURN @folderPath
END
GO

ALTER TABLE {databaseOwner}[{objectQualifier}Files] 
    ADD Folder AS {databaseOwner}[{objectQualifier}GetFileFolderFunc](FolderID) 
GO

-- --------------------------- Create Table Based Functions ------------------

CREATE FUNCTION {databaseOwner}[{objectQualifier}AdministratorRoleId](
    @PortalId	 		 Int -- Needs to be >= 0, otherwise false is returned
) 
	RETURNS 			 int
	
AS
BEGIN
	DECLARE @adminRoleId int = 0
	SELECT  @adminRoleId = AdministratorRoleId FROM {databaseOwner}[{objectQualifier}Portals] WHERE PortalID = @PortalId
	RETURN  @adminRoleId
END
GO

CREATE FUNCTION {databaseOwner}[{objectQualifier}GetListParentKey]
(
    @ParentID   AS Int,
    @ListName   AS nVarChar(500),
    @Type 		AS nVarChar(50),
    @Count 		AS Int 
)
	RETURNS nVarChar(2000)
	
AS
BEGIN
	DECLARE @KeyValue    nVarChar(2000)
	DECLARE @ListValue   nVarChar(2000)
	DECLARE @TextValue   nVarChar(2000)
	DECLARE @ReturnValue nVarChar(2000)
	DECLARE @Key         nVarChar(2000)
	
	IF @ParentID = 0
		IF @Count = 0
			SET @ReturnValue = ''
		 ELSE
			SET @ReturnValue = @ListName
	 ELSE
	 BEGIN
		SELECT @KeyValue  = ListName + '.' + [Value],
			   @TextValue = ListName + '.' + [Text], 
			   @ListValue = ListName, 
			   @ParentID  = ParentID  
		FROM {databaseOwner}{objectQualifier}Lists 
		WHERE EntryID = @ParentID

		IF @Type = 'ParentKey' OR (@Type = 'ParentList' AND @Count > 0)
			SET @ReturnValue = @KeyValue
		ELSE IF @Type = 'ParentList'
			SET @ReturnValue = @ListValue
		ELSE
			SET @ReturnValue = @TextValue
		
		IF @Count = 1 AND @Type = 'ParentList'
			SET @ReturnValue = @ReturnValue + ':' + @ListName
		ELSE IF @Count > 0
			SET @ReturnValue = @ReturnValue + '.' + @ListName
			
		SET @ReturnValue = {databaseOwner}[{objectQualifier}GetListParentKey](@ParentID, @ReturnValue, @Type, @Count + 1)
	END
	RETURN  @ReturnValue
END
GO


CREATE FUNCTION {databaseOwner}[{objectQualifier}GetProfilePropertyDefinitionID]
(   @PortalID     Int,         -- might be 0
    @PropertyName nVarChar(50) -- required
)   
	RETURNS 	  Int
	
AS
BEGIN
    DECLARE @DefinitionID Int = -1
    IF NOT IsNull(@PropertyName, '') = ''
        SELECT @DefinitionID = PropertyDefinitionID
         FROM  {databaseOwner}[{objectQualifier}ProfilePropertyDefinition]
         WHERE IsNull(PortalID, -1) = IsNull(@PortalID, -1) AND PropertyName = @PropertyName
    RETURN @DefinitionID
END
GO


CREATE FUNCTION {databaseOwner}[{objectQualifier}GetProfileFieldSql]
(
    @PortalID 	 Int,			-- Null: Host Portal
    @TemplateSql nVarChar(max)	-- template for formatting
)
	RETURNS 	 nVarChar(max)
	
AS
BEGIN
    DECLARE @sql nVarChar(max);

    SELECT @sql = IsNull(@sql + ',','') + '[' + PropertyName + ']' + @TemplateSql
     FROM {databaseOwner}[{objectQualifier}ProfilePropertyDefinition]
     WHERE IsNull(PortalID, -1) = IsNull(@PortalID, -1)
       AND Deleted = 0
    ORDER BY ViewOrder;
    RETURN (@sql)
END
GO


CREATE FUNCTION {databaseOwner}[{objectQualifier}HasChildTab]
(
   @TabId   Int	-- not null, Parent to check for child tabs
) 
	RETURNS Bit
	
AS
BEGIN
    RETURN CASE WHEN EXISTS (SELECT 1 FROM {databaseOwner}{objectQualifier}Tabs WHERE ParentId = @TabId) THEN 1 ELSE 0 END
END
GO



CREATE FUNCTION {databaseOwner}[{objectQualifier}SuperuserTabID]
() 
	RETURNS Int
	
AS
BEGIN
    DECLARE @HostTabId Int = Null
    SELECT  TOP (1) @HostTabId = TabID
      FROM  {databaseOwner}{objectQualifier}Tabs
      WHERE (PortalID IS NULL) AND (ParentId IS NULL)
      ORDER BY TabID
    RETURN @HostTabId
END
GO


CREATE FUNCTION {databaseOwner}[{objectQualifier}UserIsInRole]
(
	@UserId Int, -- Null|-1: anonymous users
	@RoleId Int  -- Null|-1: allUsers Role
)
RETURNS 	Bit
AS
BEGIN
	DECLARE @Res Bit

	IF IsNull(@RoleID, -1) = -1      -- All Users Role
		SET @Res = 1
	ELSE IF IsNull(@UserID, -1) = -1 -- Unauthenticated Users
		SET @Res = CASE WHEN @RoleId = -3 THEN 1 ELSE 0 END 
	ELSE IF @RoleId = - 2            -- Superusers Role
		SELECT @Res = IsSuperUser FROM {databaseOwner}[{objectQualifier}Users] WHERE UserID = @UserId
	ELSE
		SET @Res = CASE WHEN EXISTS (SELECT * FROM {databaseOwner}[{objectQualifier}UserRoles] 
										  WHERE UserID = @UserId AND RoleID = @RoleId 
											AND IsNull(EffectiveDate, GetDate()) >= GetDate() 
											AND IsNull(ExpiryDate,    GetDate()) <= GetDate()) THEN 1 ELSE 0 END
	RETURN IsNull(@Res, 0)
END
GO


IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'{databaseOwner}[{objectQualifier}CoreMessaging_EmailFrequency]') AND type = N'FN')
    DROP FUNCTION {databaseOwner}[{objectQualifier}CoreMessaging_EmailFrequency]
GO

IF {databaseOwner}[{objectQualifier}sys_currentDNNVersion]() >= 70200 Exec(
'CREATE FUNCTION {databaseOwner}[{objectQualifier}CoreMessaging_EmailFrequency]
(
	@UserID     		Int,  -- not Null
	@PortalID			Int,  -- not Null
	@NotificationTypeID Int   -- might be Null
)
	RETURNS Int
	
AS
BEGIN		 
	DECLARE @RetVal Int = Null
	SELECT @RetVal = CASE WHEN @NotificationTypeID IS NULL		
						THEN IsNull([MessagesEmailFrequency], 0)
						ELSE IsNull([NotificationsEmailFrequency], 2)
					 END 
	FROM {databaseOwner}[{objectQualifier}CoreMessaging_UserPreferences]  
	WHERE (UserId = @UserID) AND (PortalId = @PortalID)
	RETURN @RetVal
END')
GO



CREATE FUNCTION {databaseOwner}[{objectQualifier}Journal_ValidJournalTypesForModule]
(
	@ModuleId		 Int  -- pass Null to return all types
)
	RETURNS	TABLE
AS
	RETURN
		SELECT JournalTypeId FROM {databaseOwner}[{objectQualifier}Journal_Types]
		WHERE Not EXISTS(SELECT * FROM {databaseOwner}[{objectQualifier}Journal_TypeFilters] 
							      WHERE ModuleId = IsNull(@ModuleId, -1))
		   OR JournalTypeId IN (SELECT JournalTypeId 
		                         FROM  {databaseOwner}[{objectQualifier}Journal_TypeFilters] 
							     WHERE ModuleId = @ModuleId)
GO


-- helper View vw_FilePaths (used in function FilePath)
CREATE VIEW {databaseOwner}[{objectQualifier}vw_FilePaths]
	
AS
	SELECT     
	   F.[FileId],
	   IsNull(D.FolderPath, '') + F.FileName AS FilePath,
	   F.[Size]
	FROM       {databaseOwner}[{objectQualifier}Files]   F
    INNER JOIN {databaseOwner}[{objectQualifier}Folders] D ON F.FolderID = D.FolderID	  
GO


CREATE FUNCTION {databaseOwner}[{objectQualifier}FilePath]
(
    @StrMayContainFileId nVarChar(255)
)
	RETURNS 			 nVarChar(500)
	
AS
BEGIN
    DECLARE @Path AS nVarChar(500);

    IF ISNUll(@StrMayContainFileId,'') = ''
        SET @Path = ''
     ELSE IF Lower(@StrMayContainFileId) LIKE 'fileid=%'
        SELECT @Path = FilePath FROM {databaseOwner}[{objectQualifier}vw_FilePaths] 
         WHERE fileid = CAST(SUBSTRING(@StrMayContainFileId, 8, 10) AS Int)
     ELSE
        SET @Path = @StrMayContainFileId
    RETURN @Path -- never Null!
END
GO


-- returns file size, if fieldName like "fileid=123", otherwise 0
CREATE FUNCTION {databaseOwner}[{objectQualifier}FileSize]
(
    @StrMayContainFileId nVarChar(255)
)
	RETURNS 			 Int
	
AS
BEGIN
    DECLARE @Size Int = Null;

    IF ISNUll(@StrMayContainFileId,'') = ''
        SET @Size = Null
     ELSE IF Lower(@StrMayContainFileId) LIKE 'fileid=%'
        SELECT @Size = Size FROM {databaseOwner}[{objectQualifier}vw_FilePaths] 
         WHERE fileid = CAST(SUBSTRING(@StrMayContainFileId, 8, 10) AS Int)
     ELSE
        SET @Size = Null
    RETURN @Size -- never Null!
END
GO
-- --------------------------- Create Views ----------------------------------

-- View vw_PortalBase
IF {databaseOwner}[{objectQualifier}sys_currentDNNVersion]() < 70202 Exec('
CREATE VIEW {databaseOwner}[{objectQualifier}vw_PortalBase]
AS
    SELECT
        P.PortalID,
        P.PortalGroupID,
        PL.PortalName,
        PL.LogoFile,
        PL.FooterText,
        P.ExpiryDate,
        P.UserRegistration,
        P.BannerAdvertising,
        P.AdministratorId,
        P.Currency,
        P.HostFee,
        P.HostSpace,
        P.PageQuota,
        P.UserQuota,
        P.AdministratorRoleId,
        P.RegisteredRoleId,
        PL.Description,
        PL.KeyWords,
        PL.BackgroundFile,
        P.GUID,
        P.PaymentProcessor,
        P.ProcessorUserId,
        P.ProcessorPassword,
        P.SiteLogHistory,
        P.DefaultLanguage,
        P.TimezoneOffset,
		PL.AdminTabId,
        P.HomeDirectory,
        PL.SplashTabId,
        PL.HomeTabId,
        PL.LoginTabId,
        PL.RegisterTabId,
        PL.UserTabId,
        PL.SearchTabId,
        P.CreatedByUserID,
        P.CreatedOnDate,
        P.LastModifiedByUserID,
        P.LastModifiedOnDate,
        PL.CultureCode
    FROM       {databaseOwner}{objectQualifier}Portals            AS P
    INNER JOIN {databaseOwner}{objectQualifier}PortalLocalization AS PL ON P.PortalID = PL.PortalID
') ELSE EXEC ('
CREATE VIEW {databaseOwner}[{objectQualifier}vw_PortalBase]
AS
    SELECT
        P.PortalID,
        P.PortalGroupID,
        PL.PortalName,
        PL.LogoFile,
        PL.FooterText,
        P.ExpiryDate,
        P.UserRegistration,
        P.BannerAdvertising,
        P.AdministratorId,
        P.Currency,
        P.HostFee,
        P.HostSpace,
        P.PageQuota,
        P.UserQuota,
        P.AdministratorRoleId,
        P.RegisteredRoleId,
        PL.Description,
        PL.KeyWords,
        PL.BackgroundFile,
        P.GUID,
        P.PaymentProcessor,
        P.ProcessorUserId,
        P.ProcessorPassword,
        P.SiteLogHistory,
        P.DefaultLanguage,
        P.TimezoneOffset,
		PL.AdminTabId,
        P.HomeDirectory,
        PL.SplashTabId,
        PL.HomeTabId,
        PL.LoginTabId,
        PL.RegisterTabId,
        PL.UserTabId,
        PL.SearchTabId,
        PL.Custom404TabId,
        PL.Custom500TabId,
        P.CreatedByUserID,
        P.CreatedOnDate,
        P.LastModifiedByUserID,
        P.LastModifiedOnDate,
        PL.CultureCode
    FROM       {databaseOwner}{objectQualifier}Portals            AS P
    INNER JOIN {databaseOwner}{objectQualifier}PortalLocalization AS PL ON P.PortalID = PL.PortalID')
GO


-- View vw_Portals
IF {databaseOwner}[{objectQualifier}sys_currentDNNVersion]() < 70202 Exec('
CREATE VIEW {databaseOwner}[{objectQualifier}vw_Portals]
AS
    SELECT
        P.PortalID,
        P.PortalGroupID,
        P.PortalName,
        {databaseOwner}[{objectQualifier}FilePath](P.LogoFile) AS LogoFile,
        P.FooterText,
        P.ExpiryDate,
        P.UserRegistration,
        P.BannerAdvertising,
        P.AdministratorId,
        P.Currency,
        P.HostFee,
        P.HostSpace,
        P.PageQuota,
        P.UserQuota,
        P.AdministratorRoleId,
        P.RegisteredRoleId,
        P.Description,
        P.KeyWords,
        {databaseOwner}[{objectQualifier}FilePath](P.BackgroundFile) AS BackgroundFile,
        P.GUID,
        P.PaymentProcessor,
        P.ProcessorUserId,
        P.ProcessorPassword,
        P.SiteLogHistory,
        U.Email,
        P.DefaultLanguage,
        P.TimezoneOffset,
        P.AdminTabId,
        P.HomeDirectory,
        P.SplashTabId,
        P.HomeTabId,
        P.LoginTabId,
        P.RegisterTabId,
        P.UserTabId,
        P.SearchTabId,
        {databaseOwner}{objectQualifier}SuperuserTabID() AS SuperTabId,
        P.CreatedByUserID,
        P.CreatedOnDate,
        P.LastModifiedByUserID,
        P.LastModifiedOnDate,
        P.CultureCode
    FROM      {databaseOwner}[{objectQualifier}vw_PortalBase] P
	LEFT JOIN {databaseOwner}[{objectQualifier}Users]         U ON P.AdministratorId = U.UserId
') ELSE Exec ('
CREATE VIEW {databaseOwner}[{objectQualifier}vw_Portals]
AS
    SELECT
        P.PortalID,
        P.PortalGroupID,
        P.PortalName,
        {databaseOwner}{objectQualifier}FilePath(P.LogoFile) AS LogoFile,
        P.FooterText,
        P.ExpiryDate,
        P.UserRegistration,
        P.BannerAdvertising,
        P.AdministratorId,
        P.Currency,
        P.HostFee,
        P.HostSpace,
        P.PageQuota,
        P.UserQuota,
        P.AdministratorRoleId,
        P.RegisteredRoleId,
        P.Description,
        P.KeyWords,
        {databaseOwner}{objectQualifier}FilePath(P.BackgroundFile) AS BackgroundFile,
        P.GUID,
        P.PaymentProcessor,
        P.ProcessorUserId,
        P.ProcessorPassword,
        P.SiteLogHistory,
        U.Email,
        P.DefaultLanguage,
        P.TimezoneOffset,
        P.AdminTabId,
        P.HomeDirectory,
        P.SplashTabId,
        P.HomeTabId,
        P.LoginTabId,
        P.RegisterTabId,
        P.UserTabId,
        P.SearchTabId,
        P.Custom404TabId,
        P.Custom500TabId,
        {databaseOwner}{objectQualifier}SuperUserTabID() AS SuperTabId,
        P.CreatedByUserID,
        P.CreatedOnDate,
        P.LastModifiedByUserID,
        P.LastModifiedOnDate,
        P.CultureCode
    FROM       {databaseOwner}[{objectQualifier}vw_PortalBase]      AS P
    LEFT  JOIN {databaseOwner}[{objectQualifier}Users]              AS U  ON P.AdministratorId = U.UserID
')
GO



-- View vw_PortalsDefaultLanguage
IF {databaseOwner}[{objectQualifier}sys_currentDNNVersion]() < 70202 Exec('
CREATE VIEW {databaseOwner}[{objectQualifier}vw_PortalsDefaultLanguage]
AS
    SELECT 
        PortalID,
        PortalGroupID,
        PortalName,
        LogoFile,
        FooterText,
        ExpiryDate,
        UserRegistration,
        BannerAdvertising,
        AdministratorId,
        Currency,
        HostFee,
        HostSpace,
        PageQuota,
        UserQuota,
        AdministratorRoleId,
        RegisteredRoleId,
        Description,
        KeyWords,
        BackgroundFile,
        GUID,
        PaymentProcessor,
        ProcessorUserId,
        ProcessorPassword,
        SiteLogHistory,
        Email,
        DefaultLanguage,
        TimezoneOffset,
        AdminTabId,
        HomeDirectory,
        SplashTabId,
        HomeTabId,
        LoginTabId,
        RegisterTabId,
        UserTabId,
        SearchTabId,
        SuperTabId,
        CreatedByUserID,
        CreatedOnDate,
        LastModifiedByUserID,
        LastModifiedOnDate,
        CultureCode
	FROM {databaseOwner}[{objectQualifier}vw_Portals] WHERE CultureCode = DefaultLanguage
') ELSE Exec ('
CREATE VIEW {databaseOwner}[{objectQualifier}vw_PortalsDefaultLanguage]
AS
    SELECT 
        PortalID,
        PortalGroupID,
        PortalName,
        LogoFile,
        FooterText,
        ExpiryDate,
        UserRegistration,
        BannerAdvertising,
        AdministratorId,
        Currency,
        HostFee,
        HostSpace,
        PageQuota,
        UserQuota,
        AdministratorRoleId,
        RegisteredRoleId,
        Description,
        KeyWords,
        BackgroundFile,
        GUID,
        PaymentProcessor,
        ProcessorUserId,
        ProcessorPassword,
        SiteLogHistory,
        Email,
        DefaultLanguage,
        TimezoneOffset,
        AdminTabId,
        HomeDirectory,
        SplashTabId,
        HomeTabId,
        LoginTabId,
        RegisterTabId,
        UserTabId,
        SearchTabId,
        Custom404TabId,
        Custom500TabId,
        SuperTabId,
        CreatedByUserID,
        CreatedOnDate,
        LastModifiedByUserID,
        LastModifiedOnDate,
        CultureCode
	FROM {databaseOwner}[{objectQualifier}vw_Portals] WHERE CultureCode = DefaultLanguage
')
GO


-- View vw_MasterPortals
CREATE VIEW {databaseOwner}[{objectQualifier}vw_MasterPortals]
	
AS
	SELECT  P.PortalID,
			P.PortalGroupID,
			COALESCE(G.MasterPortalID, P.PortalID) AS MasterPortalID
	FROM      {databaseOwner}[{objectQualifier}Portals] AS P
	LEFT JOIN {databaseOwner}[{objectQualifier}PortalGroups] AS G ON P.PortalGroupID = G.PortalGroupID
GO

-- View vw_Users
CREATE VIEW {databaseOwner}[{objectQualifier}vw_Users]
	
AS
	SELECT  
		U.UserId,
        CASE WHEN IsSuperUser = 1 THEN NULL ELSE UP.PortalId END AS PortalId,
        U.Username,
        U.FirstName,
        U.LastName,
        U.DisplayName,
        U.IsSuperUser,
        U.Email,
        UP.VanityUrl,
        U.AffiliateId,
        COALESCE(UP.IsDeleted, U.IsDeleted) IsDeleted,
        UP.RefreshRoles,
        U.LastIPAddress,
        U.UpdatePassword,
        U.PasswordResetToken,
        U.PasswordResetExpiration,
        UP.Authorised,
        U.CreatedByUserId,
        U.CreatedOnDate,
        U.LastModifiedByUserId,
        U.LastModifiedOnDate
FROM      {databaseOwner}[{objectQualifier}Users]       AS U
LEFT JOIN {databaseOwner}[{objectQualifier}UserPortals] AS UP ON U.UserId = UP.UserId
GO

-- View vw_Files
CREATE VIEW {databaseOwner}[{objectQualifier}vw_Files]
AS
	SELECT     
	   F.[FileId],
       F.[PortalId],
       F.[FileName],
       F.[Extension],
       F.[Size],
       F.[Width],
       F.[Height],
       F.[ContentType],
       F.[FolderID],
       F.[Content],
       F.[CreatedByUserID],
       F.[CreatedOnDate],
       F.[LastModifiedByUserID],
       F.[LastModifiedOnDate],
       F.[UniqueId],
       F.[VersionGuid],
       F.[SHA1Hash],
       F.[LastModificationTime],
       F.[Title],
       F.[StartDate],
       F.[EnablePublishPeriod],
       F.[EndDate],
       F.[ContentItemID],
       F.[PublishedVersion],
	   D.[FolderPath][Folder],
	   D.[IsCached],
	   D.[FolderMappingID],
	   D.[StorageLocation],
	   IsNull(D.FolderPath, '') + F.FileName AS FilePath
	FROM       {databaseOwner}[{objectQualifier}Files]   F
    INNER JOIN {databaseOwner}[{objectQualifier}Folders] D ON F.FolderID = D.FolderID	  
GO

-- View vw_PublishedFiles
CREATE VIEW {databaseOwner}[{objectQualifier}vw_PublishedFiles]
	
AS
	SELECT     
		[FileId],
        [PortalId],
        [FileName],
        [Extension],
        [Size],
        [Width],
        [Height],
        [ContentType],
        [FolderID],
        [Content],
        [CreatedByUserID],
        [CreatedOnDate],
        [LastModifiedByUserID],
        [LastModifiedOnDate],
        [UniqueId],
        [VersionGuid],
        [SHA1Hash],
        [LastModificationTime],
        [Title],
        [StartDate],
        [EnablePublishPeriod],
        [EndDate],
        [ContentItemID],
        [PublishedVersion],
	    [Folder],
	    [IsCached],
	    [FolderMappingID],
	    [StorageLocation],
		[FilePath]
	FROM  {databaseOwner}[{objectQualifier}vw_Files] 
	  WHERE [EnablePublishPeriod] = 0 
		 OR ([StartDate] <= GETDATE()
		AND ([EndDate] IS NULL OR GETDATE() <= [EndDate]))
GO

	
-- view vw_ModuleBase
CREATE VIEW {databaseOwner}{objectQualifier}vw_ModuleBase

AS
    SELECT
        M.PortalID,
        M.ModuleID,
        M.ModuleDefID,
        M.AllTabs,
        M.StartDate,
        M.EndDate,
        M.InheritViewPermissions,
        M.IsShareable,
        M.IsShareableViewOnly,
        MD.DesktopModuleID,
        MD.DefaultCacheTime,
        MC.ModuleControlID,
        DM.BusinessControllerClass,
        DM.IsAdmin,
        DM.SupportedFeatures,
		DM.PackageID,
		M.ContentItemID,
        M.CreatedByUserID,
        M.CreatedOnDate,
        M.LastModifiedByUserID,
        M.LastModifiedOnDate,
        M.LastContentModifiedOnDate
    FROM        {databaseOwner}{objectQualifier}ModuleDefinitions AS MD
     INNER JOIN {databaseOwner}{objectQualifier}Modules           AS M  ON MD.ModuleDefID = M.ModuleDefID
     INNER JOIN {databaseOwner}{objectQualifier}ModuleControls    AS MC ON MD.ModuleDefID = MC.ModuleDefID
     INNER JOIN {databaseOwner}{objectQualifier}DesktopModules    AS DM ON MD.DesktopModuleID = DM.DesktopModuleID
    WHERE (MC.ControlKey IS NULL)
GO


-- view vw_ModuleTabs
CREATE VIEW {databaseOwner}{objectQualifier}vw_ModuleTabs

AS
    SELECT
        T.PortalID,
		TM.TabID,
        TM.TabModuleID,
        TM.ModuleID,
        TM.ModuleOrder,
        TM.PaneName,
        TM.ModuleTitle,
        TM.CacheTime,
        TM.CacheMethod,
        TM.Alignment,
        TM.Color,
        TM.Border,
        TM.IconFile,
        TM.Visibility,
        CASE WHEN T.IsDeleted = 0 THEN TM.IsDeleted ELSE T.IsDeleted END AS IsDeleted,
        TM.Header,
        TM.Footer,
        TM.ContainerSrc,
        TM.DisplayTitle,
        TM.DisplayPrint,
        TM.DisplaySyndicate,
        TM.IsWebSlice,
        TM.WebSliceTitle,
        TM.WebSliceExpiryDate,
        TM.WebSliceTTL,
        TM.UniqueId,
        TM.VersionGuid,
        TM.DefaultLanguageGuid,
        TM.LocalizedVersionGuid,
        TM.CultureCode,
        TM.CreatedByUserID,
        TM.CreatedOnDate,
        TM.LastModifiedByUserID,
        TM.LastModifiedOnDate
    FROM        {databaseOwner}{objectQualifier}TabModules        AS TM
     INNER JOIN {databaseOwner}{objectQualifier}Tabs              AS T  ON TM.TabID = T.TabID
GO


-- view vw_Modules
CREATE VIEW {databaseOwner}{objectQualifier}vw_Modules

AS
    SELECT
        M.PortalID AS [OwnerPortalID],
        T.PortalID,
        T.TabID,
        T.TabModuleID,
        M.ModuleID,
        M.ModuleDefID,
        T.ModuleOrder,
        T.PaneName,
        T.ModuleTitle,
        T.CacheTime,
        T.CacheMethod,
        T.Alignment,
        T.Color,
        T.Border,
        {databaseOwner}{objectQualifier}FilePath(T.IconFile) AS IconFile,
        M.AllTabs,
        T.Visibility,
        T.IsDeleted,
        T.Header,
        T.Footer,
        M.StartDate,
        M.EndDate,
        T.ContainerSrc,
        T.DisplayTitle,
        T.DisplayPrint,
        T.DisplaySyndicate,
        T.IsWebSlice,
        T.WebSliceTitle,
        T.WebSliceExpiryDate,
        T.WebSliceTTL,
        M.InheritViewPermissions,
        M.IsShareable,
        M.IsShareableViewOnly,
        M.DesktopModuleID,
        M.DefaultCacheTime,
        M.ModuleControlID,
        M.BusinessControllerClass,
        M.IsAdmin,
        M.SupportedFeatures,
		M.PackageID,
        C.ContentItemID,
        C.Content,
        C.ContentTypeID,
        C.ContentKey,
        C.Indexed,
        C.StateID,
        M.CreatedByUserID,
        M.CreatedOnDate,
        M.LastModifiedByUserID,
        M.LastModifiedOnDate,
        M.LastContentModifiedOnDate,
        T.UniqueId,
        T.VersionGuid,
        T.DefaultLanguageGuid,
        T.LocalizedVersionGuid,
        T.CultureCode
    FROM        {databaseOwner}{objectQualifier}vw_ModuleBase AS M 
     LEFT  JOIN {databaseOwner}{objectQualifier}vw_ModuleTabs AS T  ON M.ModuleID = T.ModuleID
     LEFT  JOIN {databaseOwner}{objectQualifier}ContentItems  AS C ON M.ContentItemID = C.ContentItemID
GO

-- view vw_ModulesOnTabs
IF EXISTS (select * from dbo.sysobjects where id = object_id(N'{databaseOwner}[{objectQualifier}vw_ModulesOnTabs]') and OBJECTPROPERTY(id, N'IsView') = 1)
    DROP VIEW {databaseOwner}[{objectQualifier}vw_ModulesOnTabs]
GO

CREATE VIEW {databaseOwner}{objectQualifier}vw_ModulesOnTabs
AS
    SELECT     
		M.PortalID AS [OwnerPortalID],
        T.PortalID, 
        T.TabID, 
        T.TabModuleID, 
        M.ModuleID, 
        M.ModuleDefID, 
        T.ModuleOrder, 
        T.PaneName, 
        T.ModuleTitle, 
        T.CacheTime, 
        T.CacheMethod, 
        T.Alignment, 
        T.Color, 
        T.Border, 
        T.IconFile, 
        M.AllTabs, 
        T.Visibility, 
        T.IsDeleted, 
        T.Header, 
        T.Footer, 
        M.StartDate, 
        M.EndDate, 
        T.ContainerSrc, 
        T.DisplayTitle, 
        T.DisplayPrint, 
        T.DisplaySyndicate, 
        T.IsWebSlice, 
        T.WebSliceTitle, 
        T.WebSliceExpiryDate, 
        T.WebSliceTTL, 
        M.InheritViewPermissions, 
		M.IsShareable,
		M.IsShareableViewOnly, 
        M.DesktopModuleID, 
        M.DefaultCacheTime, 
        M.ModuleControlID, 
        M.BusinessControllerClass, 
        M.IsAdmin, 
        M.SupportedFeatures,
		M.PackageID,
        M.ContentItemID,
        M.CreatedByUserID, 
        M.CreatedOnDate, 
        M.LastModifiedByUserID, 
        M.LastModifiedOnDate,
        M.LastContentModifiedOnDate,
        T.UniqueId, 
        T.VersionGuid, 
        T.DefaultLanguageGuid, 
        T.LocalizedVersionGuid,
        T.CultureCode
    FROM        {databaseOwner}{objectQualifier}vw_ModuleBase AS M
     INNER JOIN {databaseOwner}{objectQualifier}vw_ModuleTabs AS T ON M.ModuleID = T.ModuleID
GO

IF EXISTS (SELECT * FROM Sys.Views WHERE (name = N'{objectQualifier}vw_RoleUserCount'))
	DROP VIEW {databaseOwner}[{objectQualifier}vw_RoleUserCount]
GO

CREATE VIEW {databaseOwner}[{objectQualifier}vw_RoleUserCount]
AS
	SELECT U.[RoleID],
		   Count_BIG(*) UserCount
	FROM {databaseOwner}[{objectQualifier}Roles]       R
	JOIN {databaseOwner}[{objectQualifier}UserRoles]   U ON R.RoleID = U.RoleID   
	JOIN {databaseOwner}[{objectQualifier}UserPortals] P ON P.UserID = U.UserID AND P.PortalID = R.PortalID
	WHERE P.[isDeleted] = 0
	GROUP BY U.[RoleID]
GO


-- View vw_Tabs
CREATE VIEW {databaseOwner}[{objectQualifier}vw_Tabs]
	
AS
    SELECT
        T.TabID,
        T.TabOrder,
        T.PortalID,
        T.TabName,
        T.ParentId,
        T.[Level],
        T.TabPath,
        T.UniqueId,
        T.VersionGuid,
        T.DefaultLanguageGuid,
        T.LocalizedVersionGuid,
        T.IsVisible,
        {databaseOwner}{objectQualifier}FilePath(T.IconFile)      AS IconFile,
        {databaseOwner}{objectQualifier}FilePath(T.IconFileLarge) AS IconFileLarge,
        T.DisableLink,
        T.Title,
        T.Description,
        T.KeyWords,
        T.IsDeleted,
        T.SkinSrc,
        T.ContainerSrc,
        T.StartDate,
        T.EndDate,
        T.Url,
        CASE WHEN {databaseOwner}{objectQualifier}HasChildTab(T.TabID) = 1 THEN 'true' ELSE 'false' END AS HasChildren, -- I'd prefer returning a Bit value
        T.RefreshInterval,
        T.PageHeadText,
        T.IsSecure,
        T.PermanentRedirect,
        T.SiteMapPriority,
        CI.ContentItemID,
        CI.[Content],
        CI.ContentTypeID,
        CI.ModuleID,
        CI.ContentKey,
        CI.Indexed,
        CI.StateID,
        T.CultureCode,
        T.CreatedByUserID,
        T.CreatedOnDate,
        T.LastModifiedByUserID,
        T.LastModifiedOnDate
    FROM       {databaseOwner}{objectQualifier}Tabs         AS T
    LEFT  JOIN {databaseOwner}{objectQualifier}ContentItems AS CI ON T.ContentItemID = CI.ContentItemID
GO

-- View vw_TabModules
CREATE VIEW {databaseOwner}{objectQualifier}vw_TabModules
	
AS
    SELECT
        M.PortalID AS [OwnerPortalID],
        T.PortalID,
        T.TabID,
        T.TabModuleID,
        M.ModuleID,
        M.ModuleDefID,
        T.ModuleOrder,
        T.PaneName,
        T.ModuleTitle,
        T.CacheTime,
        T.CacheMethod,
        T.Alignment,
        T.Color,
        T.Border,
        {databaseOwner}{objectQualifier}FilePath(T.IconFile) AS IconFile,
        M.AllTabs,
        T.Visibility,
        T.IsDeleted,
        T.Header,
        T.Footer,
        M.StartDate,
        M.EndDate,
        T.ContainerSrc,
        T.DisplayTitle,
        T.DisplayPrint,
        T.DisplaySyndicate,
        T.IsWebSlice,
        T.WebSliceTitle,
        T.WebSliceExpiryDate,
        T.WebSliceTTL,
        M.InheritViewPermissions,
        M.IsShareable,
        M.IsShareableViewOnly,
        M.DesktopModuleID,
        M.DefaultCacheTime,
        M.ModuleControlID,
        M.BusinessControllerClass,
        M.IsAdmin,
        M.SupportedFeatures,
        C.ContentItemID,
        C.Content,
        C.ContentTypeID,
        C.ContentKey,
        C.Indexed,
        C.StateID,
        T.CreatedByUserID,
        T.CreatedOnDate,
        T.LastModifiedByUserID,
        T.LastModifiedOnDate,
        M.LastContentModifiedOnDate,
        T.UniqueId,
        T.VersionGuid,
        T.DefaultLanguageGuid,
        T.LocalizedVersionGuid,
        T.CultureCode
    FROM {databaseOwner}{objectQualifier}vw_ModuleBase         AS M
     LEFT  JOIN {databaseOwner}{objectQualifier}vw_ModuleTabs  AS T ON M.ModuleID      = T.ModuleID
     LEFT  JOIN {databaseOwner}{objectQualifier}ContentItems   AS C ON M.ContentItemID = C.ContentItemID
GO


-- View vw_PortalDesktopModules 
CREATE VIEW {databaseOwner}[{objectQualifier}vw_PortalDesktopModules]
	
AS
	SELECT
		PD.PortalDesktopModuleID, 
		PD.PortalID, 
		P.PortalName,
		P.CultureCode,
		DM.FriendlyName,
		PD.DesktopModuleID, 
		PD.CreatedByUserID, 
		PD.CreatedOnDate, 
		PD.LastModifiedByUserID, 
		PD.LastModifiedOnDate
	 FROM       {databaseOwner}[{objectQualifier}DesktopModules]        DM
	 INNER JOIN {databaseOwner}[{objectQualifier}PortalDesktopModules]  PD ON DM.DesktopModuleId = PD.DesktopModuleId
	 INNER JOIN {databaseOwner}[{objectQualifier}PortalLocalization]	P  ON PD.PortalId        = P.PortalId
GO


-- View vw_UserRoles
CREATE VIEW {databaseOwner}[{objectQualifier}vw_UserRoles]
	
AS
	SELECT     
		UR.UserRoleID, 
		R.RoleID, 
		U.UserID, 
		R.PortalID, 
		R.RoleName, 
		U.Username, 
		R.Description, 
		U.DisplayName, 
		U.Email,
		UR.Status, 
		UR.IsOwner,
		R.SecurityMode,
		R.ServiceFee, 
		R.BillingFrequency, 
		R.TrialPeriod, 
        R.TrialFrequency, 
		R.BillingPeriod, 
		R.TrialFee, 
		R.IsPublic, 
		R.AutoAssignment, 
		R.RoleGroupID, 
		R.RSVPCode, 
		R.IconFile, 
		UR.EffectiveDate, 
		UR.ExpiryDate, 
        UR.IsTrialUsed, 
		UR.CreatedByUserID, 
		UR.CreatedOnDate, 
		UR.LastModifiedByUserID, 
		UR.LastModifiedOnDate 
	FROM {databaseOwner}{objectQualifier}UserRoles AS UR 
		INNER JOIN {databaseOwner}{objectQualifier}Users AS U ON UR.UserID = U.UserID 
		INNER JOIN {databaseOwner}{objectQualifier}Roles AS R ON UR.RoleID = R.RoleID
	WHERE R.Status = 1
GO


-- View vw_ProfileDataTypes
CREATE VIEW {databaseOwner}[{objectQualifier}vw_ProfileDataTypes]
	
AS
	SELECT [EntryID] AS DataTypeID, 
		   [Value]   AS TypeName,
		   [Text]    AS ControlName
	  FROM {databaseOwner}[{objectQualifier}Lists] 
	 WHERE ListName = 'DataType'
GO


-- View vw_ProfileBase
CREATE VIEW {databaseOwner}[{objectQualifier}vw_ProfileBase]

AS
	SELECT     
		UP.UserID, 
		PD.PortalID, 
		PD.PropertyName, 
		UP.PropertyValue,
		UP.PropertyText,
		CASE WHEN PD.visible = 0 THEN 1
		     ELSE UP.Visibility
		END Visibility,
		CASE WHEN PD.visible = 1 and UP.Visibility = 3 
		     THEN UP.ExtendedVisibility
			 ELSE ''
		END ExtendedVisibility,
		PD.Deleted,
		PD.DataType,
		DT.TypeName,
		PD.PropertyDefinitionID,
		CASE WHEN UP.LastUpdatedDate > PD.LastModifiedOnDate 
		     THEN UP.LastUpdatedDate
			 ELSE PD.LastModifiedOnDate
		END LastUpdatedDate
	FROM 	   {databaseOwner}[{objectQualifier}UserProfile]               AS UP 
	INNER JOIN {databaseOwner}[{objectQualifier}ProfilePropertyDefinition] AS PD ON PD.PropertyDefinitionID = UP.PropertyDefinitionID
	INNER JOIN {databaseOwner}[{objectQualifier}vw_ProfileDataTypes]       AS DT ON PD.DataType = DT.DataTypeID
GO

-- View vw_Profile
CREATE VIEW {databaseOwner}[{objectQualifier}vw_Profile]
	
AS
	SELECT     
		P.UserID, 
		P.PortalID, 
		P.PropertyName, 
		CASE 
		 WHEN P.TypeName = 'List'            THEN IsNull(L.[Text],       P.PropertyValue)
		 WHEN IsNull(P.PropertyText,'') = '' THEN IsNull(P.PropertyText, P.PropertyValue)
		 ELSE P.PropertyText
		END AS PropertyValue, 
		P.Visibility,
		P.ExtendedVisibility,
		P.Deleted,
		P.DataType,
		P.TypeName,
		P.LastUpdatedDate,
		P.PropertyDefinitionID
	FROM 	   {databaseOwner}[{objectQualifier}vw_ProfileBase] AS P 
	LEFT  JOIN {databaseOwner}[{objectQualifier}Lists]          AS L ON L.ListName = P.PropertyName AND P.PropertyValue = L.Value
GO


-- View vw_SearchItemBase
IF {databaseOwner}[{objectQualifier}sys_currentDNNVersion]() < 70200 Exec ('
CREATE VIEW {databaseOwner}[{objectQualifier}vw_SearchItemBase]
	
AS
    SELECT     
		si.SearchItemID, 
		m.PortalID, 
		tm.TabID, 
		m.ModuleID, 
		si.Title, 
		si.Description, 
		si.Author, 
		si.PubDate, 
		si.SearchKey, 
		si.Guid, 
		si.HitCount, 
        si.ImageFileId
	FROM  		{databaseOwner}[{objectQualifier}SearchItem] AS si 
	 INNER JOIN {databaseOwner}[{objectQualifier}Modules]    AS m  ON si.ModuleID = m.ModuleID 
	 INNER JOIN {databaseOwner}[{objectQualifier}TabModules] AS tm ON m.ModuleID  = tm.ModuleID
')
GO


-- View vw_SearchItems
IF {databaseOwner}[{objectQualifier}sys_currentDNNVersion]() < 70200 Exec ('
CREATE VIEW {databaseOwner}[{objectQualifier}vw_SearchItems]
AS
    SELECT *,
           U.DisplayName AS AuthorName
	FROM      {databaseOwner}[{objectQualifier}vw_SearchItemBase] S
	LEFT JOIN {databaseOwner}[{objectQualifier}Users]             U ON S.Author = U.UserID
')
GO

-- View vw_DesktopModulePermissionBase
CREATE VIEW {databaseOwner}[{objectQualifier}vw_DesktopModulePermissionBase]
	
AS
	SELECT
		PP.DesktopModulePermissionID,
		PP.PortalDesktopModuleID,
		P.PermissionID,
		PP.RoleID,
		PP.AllowAccess,
		PP.UserID,
		P.PermissionCode,
		P.ModuleDefID,
		P.PermissionKey,
		P.PermissionName,
		PP.CreatedByUserID,
		PP.CreatedOnDate,
		PP.LastModifiedByUserID,
		PP.LastModifiedOnDate
	FROM        {databaseOwner}[{objectQualifier}DesktopModulePermission] AS PP
	 INNER JOIN {databaseOwner}[{objectQualifier}Permission]              AS P  ON PP.PermissionID = P.PermissionID
GO


-- view vw_DesktopModulePermissions
CREATE VIEW {databaseOwner}[{objectQualifier}vw_DesktopModulePermissions]
AS
	SELECT  
		P.DesktopModulePermissionID,
		P.PortalDesktopModuleID,
		P.PermissionID,
		P.RoleID,
		R.RoleName,
		P.AllowAccess,
		P.UserID,
		U.Username,
		U.DisplayName,
		P.PermissionCode,
		P.ModuleDefID,
		P.PermissionKey,
		P.PermissionName,
		P.CreatedByUserID,
		P.CreatedOnDate,
		P.LastModifiedByUserID,
		P.LastModifiedOnDate
	FROM      {databaseOwner}[{objectQualifier}vw_DesktopModulePermissionBase] P
	LEFT JOIN {databaseOwner}[{objectQualifier}Users] U ON P.UserID = U.UserID
	LEFT JOIN {databaseOwner}[{objectQualifier}Roles] R ON P.RoleID = R.RoleID
GO

-- view vw_FolderPermissionBase
CREATE VIEW {databaseOwner}[{objectQualifier}vw_FolderPermissionBase]

AS
	SELECT  
		FP.FolderPermissionID,
		F.FolderID,
		F.FolderPath,
		F.PortalID,
		P.PermissionID,
		FP.RoleID,
		FP.AllowAccess,
		FP.UserID,
		P.PermissionCode,
		P.ModuleDefID,
		P.PermissionKey,
		P.PermissionName,
		FP.CreatedByUserID,
		FP.CreatedOnDate,
		FP.LastModifiedByUserID,
		FP.LastModifiedOnDate
	FROM         {databaseOwner}[{objectQualifier}FolderPermission] AS FP
	 INNER JOIN  {databaseOwner}[{objectQualifier}Folders]          AS F ON FP.FolderID     = F.FolderID
	 INNER JOIN  {databaseOwner}[{objectQualifier}Permission]       AS P ON FP.PermissionID = P.PermissionID
GO


-- View vw_FolderPermissions
CREATE VIEW {databaseOwner}[{objectQualifier}vw_FolderPermissions]
AS
	SELECT  P.FolderPermissionID,
			P.FolderID,
			P.FolderPath,
			P.PortalID,
			P.PermissionID,
			P.RoleID,
			R.RoleName,
			P.AllowAccess,
			P.UserID,
			U.Username,
			U.DisplayName,
			P.PermissionCode,
			P.ModuleDefID,
			P.PermissionKey,
			P.PermissionName,
			P.CreatedByUserID,
			P.CreatedOnDate,
			P.LastModifiedByUserID,
			P.LastModifiedOnDate
	FROM {databaseOwner}[{objectQualifier}vw_FolderPermissionBase] P
	LEFT JOIN {databaseOwner}[{objectQualifier}Users] U ON P.UserID = U.UserID
	LEFT JOIN {databaseOwner}[{objectQualifier}Roles] R ON P.RoleID = R.RoleID
GO

-- View vw_TabPermissionBase
CREATE VIEW {databaseOwner}[{objectQualifier}vw_TabPermissionBase]
	
AS
	SELECT  
		TP.TabPermissionID,
        T.TabID,
        T.PortalId,
        P.PermissionID,
        TP.RoleID,
        TP.AllowAccess,
        TP.UserID,
        P.PermissionCode,
        P.ModuleDefID,
        P.PermissionKey,
        P.PermissionName,
        TP.CreatedByUserID,
        TP.CreatedOnDate,
        TP.LastModifiedByUserID,
        TP.LastModifiedOnDate
	FROM       {databaseOwner}[{objectQualifier}TabPermission]    AS TP
	INNER JOIN {databaseOwner}[{objectQualifier}Tabs]             AS T  ON TP.TabId        = T.TabId
	INNER JOIN {databaseOwner}[{objectQualifier}Permission]       AS P  ON TP.PermissionID = P.PermissionID
GO


-- View vw_TabPermissions
CREATE VIEW {databaseOwner}[{objectQualifier}vw_TabPermissions]
AS
	SELECT  
		P.TabPermissionID,
        P.TabID,
        P.PortalId,
        P.PermissionID,
        P.RoleID,
        R.RoleName,
        P.AllowAccess,
        P.UserID,
        U.UserName,
        U.DisplayName,
        P.PermissionCode,
        P.ModuleDefID,
        P.PermissionKey,
        P.PermissionName,
        P.CreatedByUserID,
        P.CreatedOnDate,
        P.LastModifiedByUserID,
        P.LastModifiedOnDate
	FROM {databaseOwner}[{objectQualifier}vw_TabPermissionBase] P
	LEFT JOIN {databaseOwner}[{objectQualifier}Users] U ON P.UserID = U.UserID
	LEFT JOIN {databaseOwner}[{objectQualifier}Roles] R ON P.RoleID = R.RoleID
GO

-- View vw_ModulePermissionBase
CREATE VIEW {databaseOwner}[{objectQualifier}vw_ModulePermissionBase]
AS
	SELECT  
		MP.ModulePermissionID,
        MP.ModuleID,
        MP.PortalID,
        P.PermissionID,
        MP.RoleID,
        MP.AllowAccess,
        MP.UserID,
        P.PermissionCode,
        P.ModuleDefID,
        P.PermissionKey,
        P.PermissionName,
        MP.CreatedByUserID,
        MP.CreatedOnDate,
        MP.LastModifiedByUserID,
        MP.LastModifiedOnDate
FROM        {databaseOwner}[{objectQualifier}ModulePermission] AS MP
 INNER JOIN {databaseOwner}[{objectQualifier}Permission]       AS P  ON MP.PermissionID = P.PermissionID
GO


-- View vw_ModulePermissions
CREATE VIEW {databaseOwner}[{objectQualifier}vw_ModulePermissions]
AS
	SELECT  
		P.ModulePermissionID,
        P.ModuleID,
        P.PortalID,
        P.PermissionID,
        P.RoleID,
        R.RoleName,
        P.AllowAccess,
        P.UserID,
        U.UserName ,
        U.DisplayName,
        P.PermissionCode,
        P.ModuleDefID,
        P.PermissionKey,
        P.PermissionName,
        P.CreatedByUserID,
        P.CreatedOnDate,
        P.LastModifiedByUserID,
        P.LastModifiedOnDate
	FROM {databaseOwner}[{objectQualifier}vw_ModulePermissionBase] P
	LEFT JOIN {databaseOwner}[{objectQualifier}Users] U ON P.UserID = U.UserID
	LEFT JOIN {databaseOwner}[{objectQualifier}Roles] R ON P.RoleID = R.RoleID
GO


CREATE VIEW {databaseOwner}[{objectQualifier}vw_ModulePermissionTabs]
AS
	SELECT 
		X.ModulePermissionID,
        X.ModuleID,
		T.TabID,
        T.PortalID,
        P.PermissionID,
        X.RoleID,
        X.AllowAccess,
        X.UserID,
        P.PermissionCode,
        P.ModuleDefID,
        P.PermissionKey,
        P.PermissionName,
        X.CreatedByUserID,
        X.CreatedOnDate,
        X.LastModifiedByUserID,
        X.LastModifiedOnDate
	FROM	   {databaseOwner}[{objectQualifier}Tabs]             AS T
    INNER JOIN {databaseOwner}[{objectQualifier}TabModules]       AS M ON M.TabID        = T.TabID
    INNER JOIN {databaseOwner}[{objectQualifier}ModulePermission] AS X ON M.ModuleID     = X.ModuleID	
    INNER JOIN {databaseOwner}[{objectQualifier}Permission]       AS P ON X.PermissionID = P.PermissionID
GO

CREATE VIEW {databaseOwner}[{objectQualifier}vw_ModuleSettings]
AS
	SELECT  
		T.TabID,
		S.ModuleId,
		S.SettingName,
		S.SettingValue
	FROM {databaseOwner}[{objectQualifier}TabModules]     T
	JOIN {databaseOwner}[{objectQualifier}ModuleSettings] S ON T.ModuleId = S.ModuleId
GO


CREATE VIEW {databaseOwner}[{objectQualifier}vw_TabModuleSettings]
AS
	SELECT  
		T.TabID,
		S.TabModuleId,
		S.SettingName,
		S.SettingValue
	FROM {databaseOwner}[{objectQualifier}TabModules]        T
	JOIN {databaseOwner}[{objectQualifier}TabModuleSettings] S ON T.TabModuleId = S.TabModuleId
GO


CREATE VIEW {databaseOwner}[{objectQualifier}vw_TabSettings]
AS
	SELECT  
		T.PortalID,
		S.TabID,
		S.SettingName,
		S.SettingValue
	FROM {databaseOwner}[{objectQualifier}Tabs]        T
	JOIN {databaseOwner}[{objectQualifier}TabSettings] S ON T.TabId = S.TabId
GO


CREATE VIEW {databaseOwner}[{objectQualifier}vw_ExtensionUrlProviders]
AS
	SELECT     
		P.[ExtensionUrlProviderID], 
		C.[PortalID], 
		P.[ProviderName], 
		P.[ProviderType],
		P.[SettingsControlSrc],
		P.[IsActive], 
		P.[RewriteAllUrls], 
		P.[RedirectAllUrls], 
		P.[ReplaceAllUrls], 
		P.[DesktopModuleId]
	FROM       {databaseOwner}{objectQualifier}ExtensionUrlProviderConfiguration C
	RIGHT JOIN {databaseOwner}{objectQualifier}ExtensionUrlProviders             P ON C.ExtensionUrlProviderID = P.ExtensionUrlProviderID
GO


CREATE VIEW {databaseOwner}[{objectQualifier}vw_RelationBase]
AS
	SELECT UR.UserRelationshipID, 
		   UR.UserID, 
		   UR.RelatedUserID, 
		   UR.Status, 
		   R.RelationshipID, 
		   R.Name, 
		   R.Description, 
		   R.PortalID, 
		   R.UserID Owner, 
		   RT.Direction, 
		   R.RelationshipTypeID, 
		   UR.CreatedByUserID, 
		   UR.CreatedOnDate, 
		   UR.LastModifiedByUserID, 
		   UR.LastModifiedOnDate
	 FROM  {databaseOwner}[{objectQualifier}Relationships]     AS R
	 JOIN  {databaseOwner}[{objectQualifier}RelationshipTypes] AS RT ON R.RelationshipTypeID = RT.RelationshipTypeID 
	 JOIN  {databaseOwner}[{objectQualifier}UserRelationships] AS UR ON R.RelationshipID     = UR.RelationshipID
GO


CREATE VIEW {databaseOwner}[{objectQualifier}vw_RelatedUsers]
AS
	SELECT UserRelationshipID, 
		   UserID, 
		   RelatedUserID, 
		   Status, 
		   RelationshipID, 
		   Name, 
		   Description, 
		   PortalID, 
		   Owner, 
		   Direction, 
		   RelationshipTypeID, 
		   CreatedByUserID, 
		   CreatedOnDate, 
		   LastModifiedByUserID, 
		   LastModifiedOnDate
	 FROM  {databaseOwner}[{objectQualifier}vw_RelationBase]
	UNION ( -- other direction for symmetric relations:
	SELECT UserRelationshipID, 
		   RelatedUserID, 
		   UserID, 
		   Status, 
		   RelationshipID, 
		   Name, 
		   Description, 
		   PortalID, 
		   Owner, 
		   Direction, 
		   RelationshipTypeID, 
		   CreatedByUserID, 
		   CreatedOnDate, 
		   LastModifiedByUserID, 
		   LastModifiedOnDate
	 FROM  {databaseOwner}[{objectQualifier}vw_RelationBase]
	 WHERE Direction = 2)
GO


CREATE VIEW {databaseOwner}[{objectQualifier}vw_Lists]
	
AS
	SELECT  L.EntryID, 
		L.ListName, 
		L.[Value], 
		L.Text, 
		L.[Level], 
		L.SortOrder, 
		L.DefinitionID, 
		L.ParentID, 
		L.Description, 
		L.PortalID, 
		L.SystemList, 
		{databaseOwner}[{objectQualifier}GetListParentKey](L.ParentID, L.ListName, N'ParentKey',  0) AS ParentKey, 
		{databaseOwner}[{objectQualifier}GetListParentKey](L.ParentID, L.ListName, N'Parent',     0) AS Parent, 
		{databaseOwner}[{objectQualifier}GetListParentKey](L.ParentID, L.ListName, N'ParentList', 0) AS ParentList,
		S.MaxSortOrder,
		S.EntryCount,
		CASE WHEN EXISTS (SELECT 1 FROM {databaseOwner}[{objectQualifier}Lists] WHERE (ParentID = L.EntryID)) THEN 1 ELSE 0 END AS HasChildren, 
		L.CreatedByUserID, 
		L.CreatedOnDate, 
		L.LastModifiedByUserID, 
		L.LastModifiedOnDate
	FROM {databaseOwner}[{objectQualifier}Lists] AS L
	LEFT JOIN (SELECT ListName, ParentID, Max(SortOrder) AS MaxSortOrder, Count(1) AS EntryCount 
			   FROM {databaseOwner}[{objectQualifier}Lists] GROUP BY ListName, ParentID) S 		ON L.ParentID = S.ParentId AND L.ListName = S.ListName
GO


CREATE VIEW {databaseOwner}[{objectQualifier}vw_ContentWorkflowStatePermissions]
	
AS
    SELECT     
	    WSP.WorkflowStatePermissionID,  
	    WSP.StateID, 
	    P.PermissionID, 
	    WSP.RoleID,
		R.RoleName,
	    WSP.AllowAccess, 
	    WSP.UserID,
	    U.Username,
	    U.DisplayName, 
	    P.PermissionCode, 
	    P.ModuleDefID, 
	    P.PermissionKey, 
	    P.PermissionName, 
        WSP.CreatedByUserID, 
        WSP.CreatedOnDate, 
        WSP.LastModifiedByUserID, 
        WSP.LastModifiedOnDate    
    FROM      {databaseOwner}{objectQualifier}ContentWorkflowStatePermission AS WSP 
	LEFT JOIN {databaseOwner}{objectQualifier}Permission      AS P ON WSP.PermissionID = P.PermissionID 
	LEFT JOIN {databaseOwner}{objectQualifier}Roles           AS R ON WSP.RoleID = R.RoleID
	LEFT JOIN {databaseOwner}{objectQualifier}Users           AS U ON WSP.UserID = U.UserID
GO

-- View vw_CoreMessaging_Messages
IF ({databaseOwner}[{objectQualifier}sys_currentDNNVersion]() >= 70200) Exec ('
CREATE VIEW {databaseOwner}[{objectQualifier}vw_CoreMessaging_Messages]
AS
	SELECT
		M.MessageID, 
		M.PortalID, 
		M.NotificationTypeID, 
		M.[To], 
		M.[From],
		M.Subject,
		M.Body,
		M.ConversationID, 
		M.ReplyAllAllowed, 
		M.SenderUserID,
		M.ExpirationDate, 
        M.Context, 
		M.IncludeDismissAction,
		M.CreatedByUserID, 
		M.CreatedOnDate, 
		M.LastModifiedByUserID, 
		M.LastModifiedOnDate, 
		MR.RecipientID,
		MR.UserID, 
        MR.[Read], 
		MR.Archived, 
		MR.SendToast,
		MR.EmailSent, 
		MR.EmailSentDate, 
		MR.EmailSchedulerInstance
	FROM       {databaseOwner}[{objectQualifier}CoreMessaging_MessageRecipients] MR
	INNER JOIN {databaseOwner}[{objectQualifier}CoreMessaging_Messages]          M ON mr.MessageID = m.MessageID')
ELSE Exec('
CREATE VIEW {databaseOwner}[{objectQualifier}vw_CoreMessaging_Messages]
AS
	SELECT
		M.MessageID, 
		M.PortalID, 
		M.NotificationTypeID, 
		M.[To], 
		M.[From],
		M.Subject,
		M.Body,
		M.ConversationID, 
		M.ReplyAllAllowed, 
		M.SenderUserID,
		M.ExpirationDate, 
        M.Context, 
		M.IncludeDismissAction,
		M.CreatedByUserID, 
		M.CreatedOnDate, 
		M.LastModifiedByUserID, 
		M.LastModifiedOnDate, 
		MR.RecipientID,
		MR.UserID, 
        MR.[Read], 
		MR.Archived, 
		MR.EmailSent, 
		MR.EmailSentDate, 
		MR.EmailSchedulerInstance
	FROM       {databaseOwner}[{objectQualifier}CoreMessaging_MessageRecipients] MR
	INNER JOIN {databaseOwner}[{objectQualifier}CoreMessaging_Messages]          M ON mr.MessageID = m.MessageID
')
GO



-- View vw_CoreMessaging_Recipients
IF ({databaseOwner}[{objectQualifier}sys_currentDNNVersion]() >= 70200) Exec ('
CREATE VIEW {databaseOwner}[{objectQualifier}vw_CoreMessaging_Recipients]
	
AS
	SELECT
		M.MessageID, 
		M.PortalID, 
		M.NotificationTypeID, 
		M.[To], 
		M.[From],
		M.Subject,
		M.Body,
		M.ConversationID, 
		M.ReplyAllAllowed, 
		M.SenderUserID,
		M.ExpirationDate, 
        M.Context, 
		M.IncludeDismissAction,
		MR.RecipientID,
		MR.UserID, 
        MR.[Read], 
		MR.Archived, 
		MR.EmailSent, 
		MR.EmailSentDate, 
		MR.EmailSchedulerInstance,
		MR.SendToast,
		MR.CreatedByUserID, 
		MR.CreatedOnDate, 
		MR.LastModifiedByUserID, 
		MR.LastModifiedOnDate
	FROM       {databaseOwner}[{objectQualifier}CoreMessaging_MessageRecipients] MR
	INNER JOIN {databaseOwner}[{objectQualifier}CoreMessaging_Messages]          M ON mr.MessageID = m.MessageID
') ELSE Exec ('
CREATE VIEW {databaseOwner}[{objectQualifier}vw_CoreMessaging_Recipients]
	
AS
	SELECT
		M.MessageID, 
		M.PortalID, 
		M.NotificationTypeID, 
		M.[To], 
		M.[From],
		M.Subject,
		M.Body,
		M.ConversationID, 
		M.ReplyAllAllowed, 
		M.SenderUserID,
		M.ExpirationDate, 
        M.Context, 
		M.IncludeDismissAction,
		MR.RecipientID,
		MR.UserID, 
        MR.[Read], 
		MR.Archived, 
		MR.EmailSent, 
		MR.EmailSentDate, 
		MR.EmailSchedulerInstance,
		MR.CreatedByUserID, 
		MR.CreatedOnDate, 
		MR.LastModifiedByUserID, 
		MR.LastModifiedOnDate
	FROM       {databaseOwner}[{objectQualifier}CoreMessaging_MessageRecipients] MR
	INNER JOIN {databaseOwner}[{objectQualifier}CoreMessaging_Messages]          M ON mr.MessageID = m.MessageID
')
GO


-- View vw:MessagesForDispatch
IF {databaseOwner}[{objectQualifier}sys_currentDNNVersion]() >= 72000 Exec('
CREATE VIEW {databaseOwner}[{objectQualifier}vw_MessagesForDispatch]

AS 
	SELECT 
		RecipientID,
		MessageID,
		UserID,
		[Read],
		Archived,
		EmailSent,
		EmailSentDate,
		EmailSchedulerInstance,
		CreatedByUserID,
		CreatedOnDate,
		LastModifiedByUserID,
		LastModifiedOnDate,
		SendToast,
		NotificationTypeID,
		databaseOwner}[{objectQualifier}CoreMessaging_EmailFrequency](UserID, PortalID, NotificationTypeID) AS EmailFrequency
	FROM {databaseOwner}[{objectQualifier}vw_CoreMessaging_Recipients] 
')
GO


IF EXISTS (select * from dbo.sysobjects where id = object_id(N'{databaseOwner}[{objectQualifier}vw_JournalBase]') AND OBJECTPROPERTY(id, N'IsView') = 1)
    DROP VIEW {databaseOwner}[{objectQualifier}vw_JournalBase]
GO

CREATE View {databaseOwner}[{objectQualifier}vw_JournalBase]
	
AS
	SELECT J.JournalId, 
		   J.JournalTypeId, 
		   T.JournalType, 
		   T.icon, 
		   J.UserId, 
		   J.DateCreated, 
		   J.DateUpdated, 
		   J.PortalId, 
		   J.ProfileId, 
		   J.GroupId, 
		   J.Title, 
		   J.Summary, 
		   J.ItemData, 
           J.ImageURL, 
		   J.ObjectKey, 
		   J.AccessKey, 
		   J.ContentItemId, 
		   J.IsDeleted, 
		   J.CommentsDisabled, 
		   J.CommentsHidden
	FROM       {databaseOwner}[{objectQualifier}Journal]       J
	INNER JOIN {databaseOwner}[{objectQualifier}Journal_Types] T ON J.JournalTypeID = T.JournalTypeID
GO


CREATE View {databaseOwner}[{objectQualifier}vw_JournalItems]
	
AS
	SELECT J.JournalId, 
		   J.JournalTypeId, 
		   J.JournalType, 
		   J.icon, 
		   J.UserId, 
		   J.DateCreated, 
		   J.DateUpdated, 
		   J.PortalId, 
		   J.ProfileId, 
		   J.GroupId, 
		   J.Title, 
		   J.Summary, 
		   J.ItemData, 
           J.ImageURL, 
		   J.ObjectKey, 
		   J.AccessKey, 
		   J.ContentItemId, 
		   J.IsDeleted, 
		   J.CommentsDisabled, 
		   J.CommentsHidden,
		   D.JournalXML
	FROM       {databaseOwner}[{objectQualifier}vw_JournalBase] AS J 
	LEFT  JOIN {databaseOwner}[{objectQualifier}Journal_Data]   AS D ON J.JournalID = D.JournalID
GO


CREATE View {databaseOwner}[{objectQualifier}vw_JournalSecurity]
	
AS
	SELECT J.JournalId,
		   J.JournalTypeId,		
		   J.PortalId,
		   J.UserId,
		   J.ProfileId,
		   J.GroupId,
		   J.ObjectKey,
		   J.DateCreated,
		   J.IsDeleted,
		   S.SecurityKey
	FROM  	   {databaseOwner}[{objectQualifier}Journal] 		  AS J
	INNER JOIN {databaseOwner}[{objectQualifier}Journal_Security] AS S ON J.JournalId = S.JournalId
GO


CREATE View {databaseOwner}[{objectQualifier}vw_JournalTypeFilters]
AS
	SELECT 
		F.PortalId,
		F.ModuleId,
		F.JournalTypeId, 
		T.JournalType
	FROM       {databaseOwner}[{objectQualifier}Journal_Types]       AS T 
	INNER JOIN {databaseOwner}[{objectQualifier}Journal_TypeFilters] AS F ON F.JournalTypeId = T.JournalTypeId
GO


CREATE View {databaseOwner}[{objectQualifier}vw_JournalComments]
AS
	SELECT C.CommentId, 
		   C.JournalId, 
		   C.UserId, 
		   C.[Comment], 
		   C.DateCreated, 
		   C.DateUpdated, 
		   C.CommentXML, 
		   U.Username, 
		   U.FirstName, 
		   U.LastName, 
		   U.IsSuperUser, 
		   U.AffiliateId, 
		   U.Email, 
		   U.DisplayName, 
		   U.LastIPAddress, 
		   U.IsDeleted, 
		   U.CreatedByUserID, 
		   U.CreatedOnDate, 
		   U.LastModifiedByUserID, 
           U.LastModifiedOnDate
	FROM       {databaseOwner}[{objectQualifier}Journal_Comments] AS C 
	INNER JOIN {databaseOwner}[{objectQualifier}Users] 			  AS U ON C.UserID = U.UserId
GO


-- --------------------------- Create View Based Functions -------------------
CREATE FUNCTION {databaseOwner}[{objectQualifier}FitsExtendedPropertyPermission](
    @viewingUserId 		 Int,
    @viewedUserID 		 Int,
    @extendedPermissions nVarChar(2000)
) 
	RETURNS 			 Bit
	
AS
BEGIN
    DECLARE @rolesStr    nVarChar(2000) = ''
    DECLARE @reltnStr    nVarChar(2000) = ''
    DECLARE @gStartPos   Int
    DECLARE @rStartPos   Int
    DECLARE @recCount    Int = 0
    DECLARE @SQL         Int
    If (@viewedUserID > 0 and Len(IsNull(@extendedPermissions,'')) > 2) BEGIN
        SET @gStartPos = CHARINDEX('G:',@extendedPermissions) + 2
        SET @rStartPos = CHARINDEX('R:',@extendedPermissions) + 2
        if @gStartPos > @rStartPos BEGIN
            SET @rolesStr = SUBSTRING(@extendedPermissions, @gStartPos, Len(@extendedPermissions) - @gStartPos)
            if @rStartPos > 0 SET @reltnStr = SUBSTRING(@extendedPermissions, @rStartPos, @gStartPos - @rStartPos - 1)
        END
        If @gStartPos < @rStartPos BEGIN
            SET @reltnStr = SUBSTRING(@extendedPermissions, @rStartPos, Len(@extendedPermissions) - @rStartPos)
            if @gStartPos > 0 SET @rolesStr = SUBSTRING(@extendedPermissions, @gStartPos, @rStartPos - @gStartPos - 1)
        END
        If @rolesStr <> '' BEGIN
            SET @rolesStr = ',' + SUBSTRING(@rolesStr,1, Len(@rolesStr) - CASE WHEN RIGHT(@RolesStr,1) = ';' THEN 1 ELSE 0 END)
            SELECT @recCount = COUNT(1) FROM {databaseOwner}[{objectQualifier}UserRoles] WHERE UserID = @viewingUserId AND @rolesStr LIKE '%,' + Convert(nVarChar(10),RoleId) + ',%'
        END
        If @recCount = 0 AND @reltnStr <> '' BEGIN
            SET @reltnStr = ',' + SUBSTRING(@reltnStr,1, Len(@reltnStr) - CASE WHEN RIGHT(@reltnStr,1) = ';' THEN 1 ELSE 0 END)
            SELECT @recCount = COUNT(1) FROM {databaseOwner}[{objectQualifier}vw_RelatedUsers] WHERE UserID = @viewingUserId AND relatedUserID = @viewedUserId AND @reltnStr LIKE '%,' + Convert(nVarChar(10),RelationShipID) + ',%' AND Status = 2
        END
    END
    RETURN CASE WHEN IsNull(@RecCount, 0) > 0 THEN 1 ELSE 0 END
END
GO


CREATE FUNCTION {databaseOwner}[{objectQualifier}MasterPortalId]
(
    @PortalId Int  -- ID of the portal or Null for Host
) 
	RETURNS   Int
	
AS
BEGIN
    DECLARE @MasterPortalId  Int = Null
    IF IsNull(@PortalId, -1) >= 0
        SELECT @MasterPortalId = MasterPortalId 
		FROM {databaseOwner}[{objectQualifier}vw_MasterPortals]
		WHERE PortalId = @PortalId
    RETURN @MasterPortalId
END
GO


CREATE FUNCTION {databaseOwner}[{objectQualifier}GetUsersByPropertyName]
(
	@PropertyName	nVarChar(100),  -- Not Null
	@PropertyValue	nVarChar(max),  -- Not Null
	@PortalID 		Int				-- Null|-1 for Host Porperties
)
	RETURNS TABLE
	
AS
	RETURN SELECT *
			FROM  {databaseOwner}[{objectQualifier}vw_Profile] 
			WHERE PropertyName  LIKE @PropertyName 
			  AND PropertyValue LIKE @PropertyValue
			  AND IsNull(PortalID, -1) = IsNull(@PortalID, -1)
GO


-- not checking for UserPortal, expecting being called by authorized users only
CREATE FUNCTION {databaseOwner}[{objectQualifier}Journal_PermittedJournalIDs]
(	@PortalID		Int, -- Not Null
	@CurrentUserID	Int  -- Not Null
)
	RETURNS Table
AS	
	RETURN 
(		SELECT DISTINCT
			JournalID, 
			JournalTypeId,
			PortalID,
			ProfileID,
			GroupID,
			isDeleted
		FROM {databaseOwner}[{objectQualifier}vw_JournalSecurity] 
		WHERE (PortalID = @PortalID)
		  AND (SecurityKey = 'E' -- everyOne
		   OR  SecurityKey = 'U' + Cast(@CurrentUserID AS nVarChar(11)) -- Own Item
		   OR  SecurityKey = 'P' + Cast(@CurrentUserID AS nVarChar(11)) -- Permitted Item
		   OR  SecurityKey = 'F' + Cast(@CurrentUserID AS nVarChar(11)) -- Own Item
		   OR  SecurityKey = 'C' + Cast((SELECT RoleId                  -- RegisteredUsers
		                                  FROM  {databaseOwner}[{objectQualifier}UserRoles] 
										  WHERE RoleID IN (SELECT RegisteredRoleId FROM {databaseOwner}[{objectQualifier}Portals] WHERE PortalID = @PortalID)
										    AND UserID = @CurrentUserID) AS nVarChar(11))
		   OR  SecurityKey IN (SELECT 'R' + Cast(RoleID AS nVarChar(11)) 
								FROM  {databaseOwner}[{objectQualifier}vw_UserRoles]
							    WHERE (PortalId = @PortalId)           -- granted Roles
								  AND (UserID   = @CurrentUserID)
								  AND (EffectiveDate <= getdate() OR EffectiveDate IS Null)
                                  AND (ExpiryDate    >= getdate() OR ExpiryDate    IS Null))
		   OR  SecurityKey IN (SELECT 'F' + Cast(RelatedUserID AS nVarChar(11))
							    FROM  {databaseOwner}[{objectQualifier}vw_RelatedUsers] 
							    WHERE (UserID = @CurrentUserID AND Status = 2))) -- related user
);
GO

/*
CREATE FUNCTION {databaseOwner}[{objectQualifier}Journal_User_Permissions]
(
	@PortalId 			Int, -- Not Null
	@UserId 			Int, -- Null|-1 for anonymous visitors
	@RegisteredRoleId 	Int  -- Not Null
)
RETURNS 
	@tmp 				TABLE (secKey nVarChar(20))
	
AS
BEGIN
	IF IsNull(@UserId, -1) > 0 BEGIN
		INSERT INTO @tmp (secKey) VALUES ('U' + Cast(@UserId AS nvarchar(19)))
		INSERT INTO @tmp (secKey) VALUES ('P' + Cast(@UserId AS nvarchar(19)))
		INSERT INTO @tmp (secKey) VALUES ('F' + Cast(@UserId AS nvarchar(19)))
		IF EXISTS (SELECT RoleId FROM {databaseOwner}[{objectQualifier}UserRoles]
				   WHERE UserID = @UserId 
					 AND RoleId = @RegisteredRoleId
					 AND IsNull(EffectiveDate, GetDate()) <= GetDate()
					 AND IsNull(ExpiryDate,    GetDate()) <= GetDate()
				  )
			INSERT INTO @tmp (secKey) VALUES ('C') -- is member of registeredRole
	END
		
	INSERT INTO @tmp (secKey) VALUES ('E')
	
	-- Roles
	DECLARE @Now DateTime = GetDate()
	
	INSERT INTO @tmp (secKey)
	SELECT 'R' + CAST(RoleId AS nvarchar(19)) 
		FROM {databaseOwner}[{objectQualifier}vw_UserRoles]
		WHERE UserId   = @UserId
		  AND PortalId = @PortalId
		  AND IsNull(EffectiveDate, @Now) <= @Now
		  AND IsNull(ExpiryDate,    @Now) <= @Now
			
	-- Friends
	INSERT INTO @tmp (secKey)
		SELECT 'F' + CAST(CASE WHEN @UserID = UserId THEN RelatedUserID	ELSE UserId END AS nvarchar(19)) 
		FROM  {databaseOwner}[{objectQualifier}UserRelationships] 
		WHERE (UserId = @UserId OR RelatedUserID = @UserId) 
		  AND RelationshipID IN (SELECT RelationshipID 
								   FROM {databaseOwner}[{objectQualifier}Relationships] 
								  WHERE RelationshipTypeID = 1)
		  AND Status = 2
	RETURN 
END
*/
GO


-- --------------------------- Create View Based Procedures ------------------
IF {databaseOwner}[{objectQualifier}sys_currentDNNVersion]() >= 70202
Exec('
CREATE PROCEDURE {databaseOwner}[{objectQualifier}GetFile]
	@FileName nVarChar(246), -- Not Null
	@FolderID Int,           -- Not Null
	@RetrieveUnpublishedFiles Bit = 0
AS
BEGIN
	SET NOCOUNT ON;
	IF @RetrieveUnpublishedFiles = 0 
		SELECT  FileId,
				PortalId,
				[FileName],
				Extension,
				Size,
				Width,
				Height,
				ContentType,
				FolderID,
				Folder,
				StorageLocation,
				IsCached,
				UniqueId,
				VersionGuid,	   
				SHA1Hash,
				FolderMappingID,
				LastModificationTime,
				Title,
				EnablePublishPeriod,
				StartDate,
				EndDate,
				CreatedByUserID,
				CreatedOnDate,
				LastModifiedByUserID,
				LastModifiedOnDate,
				ContentItemID,
				PublishedVersion
		FROM {databaseOwner}[{objectQualifier}vw_PublishedFiles]
		WHERE [FileName] = @FileName 
		  AND [FolderID] = @FolderID
	ELSE 
		SELECT 
			FileId,
			PortalId,
			[FileName],
			Extension,
			Size,
			Width,
			Height,
			ContentType,
			FolderID,
			Folder,
			StorageLocation,
			IsCached,
			FolderMappingID,
			UniqueId,
			VersionGuid,	   
			SHA1Hash,
			LastModificationTime,
			Title,
			EnablePublishPeriod,
			StartDate,
			EndDate,
			CreatedByUserID,
			CreatedOnDate,
			LastModifiedByUserID,
			LastModifiedOnDate,
			ContentItemID,
			PublishedVersion
		FROM  {databaseOwner}[{objectQualifier}vw_Files] 
		WHERE [FileName] = @FileName
		  AND [FolderID] = @FolderID;
	SET NOCOUNT OFF;
END
') ELSE Exec (	'
CREATE PROCEDURE {databaseOwner}[{objectQualifier}GetFile]
	@FileName nVarChar(246), -- Not Null
	@FolderID Int,           -- Not Null
	@RetrieveUnpublishedFiles Bit = 0
AS
BEGIN
	SET NOCOUNT ON;
	IF @RetrieveUnpublishedFiles = 0 
		SELECT  FileId,
				PortalId,
				[FileName],
				Extension,
				Size,
				Width,
				Height,
				ContentType,
				FolderID,
				Folder,
				StorageLocation,
			    IsCached,
				UniqueId,
				VersionGuid,	   
				SHA1Hash,
				FolderMappingID,
				LastModificationTime,
				Title,
				EnablePublishPeriod,
				StartDate,
				EndDate,
				CreatedByUserID,
				CreatedOnDate,
				LastModifiedByUserID,
				LastModifiedOnDate,
				ContentItemID,
				PublishedVersion
		FROM {databaseOwner}[{objectQualifier}vw_PublishedFiles]
		WHERE [FileName] = @FileName 
		  AND [FolderID] = @FolderID
	ELSE 
		SELECT 
			FileId,
			PortalId,
			[FileName],
			Extension,
			Size,
			Width,
			Height,
			ContentType,
			FolderID,
			Folder,
			StorageLocation,
			IsCached,
			UniqueId,
			VersionGuid,	   
			SHA1Hash,
			FolderMappingID,
			LastModificationTime,
			Title,
			EnablePublishPeriod,
			StartDate,
			EndDate,
			CreatedByUserID,
			CreatedOnDate,
			LastModifiedByUserID,
			LastModifiedOnDate,
			ContentItemID,
			PublishedVersion
		FROM  {databaseOwner}[{objectQualifier}vw_Files] 
		WHERE [FileName] = @FileName
		  AND [FolderID] = @FolderID;
	SET NOCOUNT OFF;
END')
GO


IF {databaseOwner}[{objectQualifier}sys_currentDNNVersion]() >= 70202
Exec('
CREATE PROCEDURE {databaseOwner}[{objectQualifier}GetFileById]
	@FileId Int,	 				  -- Not Null
	@RetrieveUnpublishedFiles Bit = 0 -- Not Null
AS
BEGIN
	SET NOCOUNT ON;
	IF @RetrieveUnpublishedFiles = 0 
		SELECT 
		   FileId,
		   PortalId,
		   [FileName],
		   Extension,
		   Size,
		   Width,
		   Height,
		   ContentType,
		   FolderID,
		   Folder,
		   StorageLocation,
		   IsCached,
		   UniqueId,
		   VersionGuid,
		   SHA1Hash,
		   FolderMappingID,
		   LastModificationTime,
		   Title,
		   EnablePublishPeriod,
		   StartDate,
		   EndDate,
		   CreatedByUserID,
		   CreatedOnDate,
		   LastModifiedByUserID,
		   LastModifiedOnDate,
		   PublishedVersion,
		   ContentItemID	
		FROM {databaseOwner}[{objectQualifier}vw_PublishedFiles] 
		WHERE FileId = @FileId
	ELSE
		SELECT FileId,
		   PortalId,
		   [FileName],
		   Extension,
		   Size,
		   Width,
		   Height,
		   ContentType,
		   FolderID,
		   Folder,
		   StorageLocation,
		   IsCached,
		   [UniqueId],
		   [VersionGuid],
		   SHA1Hash,
		   FolderMappingID,
		   LastModificationTime,
		   Title,
		   EnablePublishPeriod,
		   StartDate,
		   EndDate,
		   CreatedByUserID,
		   CreatedOnDate,
		   LastModifiedByUserID,
		   LastModifiedOnDate,
		   PublishedVersion,
		   ContentItemID
		FROM  {databaseOwner}[{objectQualifier}vw_Files]
		WHERE FileId = @FileId;
	SET NOCOUNT OFF;
END
') ELSE Exec('
CREATE PROCEDURE {databaseOwner}[{objectQualifier}GetFileById]
	@FileId Int,	 				  -- Not Null
	@RetrieveUnpublishedFiles Bit = 0 -- Not Null
AS
BEGIN
	SET NOCOUNT ON;
	IF @RetrieveUnpublishedFiles = 0
		SELECT 
		   FileId,
		   PortalId,
		   [FileName],
		   Extension,
		   Size,
		   Width,
		   Height,
		   ContentType,
		   FolderID,
		   Folder,
		   StorageLocation,
		   IsCached,
		   UniqueId,
		   VersionGuid,
		   SHA1Hash,
		   FolderMappingID,
		   LastModificationTime,
		   Title,
		   EnablePublishPeriod,
		   StartDate,
		   EndDate,
		   CreatedByUserID,
		   CreatedOnDate,
		   LastModifiedByUserID,
		   LastModifiedOnDate,
		   PublishedVersion,
		   ContentItemID
		FROM  {databaseOwner}[{objectQualifier}vw_PublishedFiles] 
		WHERE FileId = @FileId
	ELSE
		SELECT 
		   FileId,
		   PortalId,
		   [FileName],
		   Extension,
		   Size,
		   Width,
		   Height,
		   ContentType,
		   FolderID,
		   Folder,
		   StorageLocation,
		   IsCached,
		   [UniqueId],
		   [VersionGuid],
		   SHA1Hash,
		   FolderMappingID,
		   LastModificationTime,
		   Title,
		   EnablePublishPeriod,
		   StartDate,
		   EndDate,
		   CreatedByUserID,
		   CreatedOnDate,
		   LastModifiedByUserID,
		   LastModifiedOnDate,
		   PublishedVersion,
		   ContentItemID
	 FROM  {databaseOwner}[{objectQualifier}vw_Files]
	 WHERE FileId = @FileId;
	SET NOCOUNT OFF;
END
')
GO


IF {databaseOwner}[{objectQualifier}sys_currentDNNVersion]() >= 70202 Exec('
CREATE PROCEDURE {databaseOwner}[{objectQualifier}GetFiles]
    @FolderID Int,                      -- not Null!
    @RetrieveUnpublishedFiles Bit = 0   -- include files, hidden by status or date?
AS
BEGIN
	SET NOCOUNT ON;
	IF @RetrieveUnpublishedFiles = 0 
		SELECT FileId,
			   PortalId,
			   [FileName],
			   Extension,
			   [Size],
			   Width,
			   Height,
			   ContentType,
			   FolderID,
			   Folder,
			   StorageLocation,
			   IsCached,
			   FolderMappingID,
			   UniqueId,
			   VersionGuid,
			   SHA1Hash,
			   LastModificationTime,
			   Title,
			   EnablePublishPeriod,
			   StartDate,
			   EndDate,
			   CreatedByUserID,
			   CreatedOnDate,
			   LastModifiedByUserID,
			   LastModifiedOnDate,
			   PublishedVersion,
			   ContentItemID
		 FROM  {databaseOwner}[{objectQualifier}vw_PublishedFiles]
		 WHERE FolderID = @FolderID
		 ORDER BY [FolderID], [FileName]
		 OPTION (OPTIMIZE FOR (@FolderID UNKNOWN))
	ELSE 
		SELECT FileId,
			   PortalId,
			   [FileName],
			   Extension,
			   [Size],
			   Width,
			   Height,
			   ContentType,
			   FolderID,
			   Folder,
			   StorageLocation,
			   IsCached,
			   FolderMappingID,
			   UniqueId,
			   VersionGuid,
			   SHA1Hash,
			   LastModificationTime,
			   Title,
			   EnablePublishPeriod,
			   StartDate,
			   EndDate,
			   CreatedByUserID,
			   CreatedOnDate,
			   LastModifiedByUserID,
			   LastModifiedOnDate,
			   PublishedVersion,
			   ContentItemID
		 FROM  {databaseOwner}[{objectQualifier}vw_Files]
		 WHERE FolderID = @FolderID
		 ORDER BY [FolderID], [FileName]
		 OPTION (OPTIMIZE FOR (@FolderID UNKNOWN));
	SET NOCOUNT OFF;
END
') ELSE Exec ('
CREATE PROCEDURE {databaseOwner}[{objectQualifier}GetFiles]
    @FolderID Int,                      -- not Null!
    @RetrieveUnpublishedFiles Bit = 0   -- include files, hidden by status or date?
AS
BEGIN
	SET NOCOUNT ON;
	IF @RetrieveUnpublishedFiles = 0 
		SELECT FileId,
			   PortalId,
			   [FileName],
			   Extension,
			   [Size],
			   Width,
			   Height,
			   ContentType,
			   FolderID,
			   Folder,
			   StorageLocation,
			   IsCached,
			   UniqueId,
			   VersionGuid,
			   SHA1Hash,
			   FolderMappingID,
			   LastModificationTime,
			   Title,
			   EnablePublishPeriod,
			   StartDate,
			   EndDate,
			   CreatedByUserID,
			   CreatedOnDate,
			   LastModifiedByUserID,
			   LastModifiedOnDate,
			   PublishedVersion,
			   ContentItemID
		 FROM  {databaseOwner}[{objectQualifier}vw_PublishedFiles]
		 WHERE FolderID = @FolderID
		 ORDER BY [FolderID], [FileName]
		 OPTION (OPTIMIZE FOR (@FolderID UNKNOWN))
	ELSE
		SELECT FileId,
			   PortalId,
			   [FileName],
			   Extension,
			   [Size],
			   Width,
			   Height,
			   ContentType,
			   FolderID,
			   Folder,
			   StorageLocation,
			   IsCached,
			   UniqueId,
			   VersionGuid,
			   SHA1Hash,
			   FolderMappingID,
			   LastModificationTime,
			   Title,
			   EnablePublishPeriod,
			   StartDate,
			   EndDate,
			   CreatedByUserID,
			   CreatedOnDate,
			   LastModifiedByUserID,
			   LastModifiedOnDate,
			   PublishedVersion,
			   ContentItemID
		 FROM  {databaseOwner}[{objectQualifier}vw_Files] 
		 WHERE FolderID = @FolderID
		 ORDER BY [FolderID], [FileName]
		 OPTION (OPTIMIZE FOR (@FolderID UNKNOWN))
	SET NOCOUNT OFF;
END
')
GO


CREATE PROCEDURE {databaseOwner}[{objectQualifier}GetModule]
	@ModuleId 	Int, -- Not Null
	@TabId    	Int  -- Null|-1: Module on all tabs
AS
	IF (@TabId Is Null) -- all references of a module
		SELECT * 
		FROM  {databaseOwner}{objectQualifier}vw_Modules
		WHERE ModuleId = @ModuleId
	 ELSE               -- single module instance on a page
		SELECT
			V.[OwnerPortalID],
			V.[PortalID],
			V.[TabID],
			V.[TabModuleID],
			V.[ModuleID],
			V.[ModuleDefID],
			V.[ModuleOrder],
			V.[PaneName],
			V.[ModuleTitle],
			V.[CacheTime],
			V.[CacheMethod],
			V.[Alignment],
			V.[Color],
			V.[Border],
			{databaseOwner}{objectQualifier}FilePath(V.[IconFile]) AS IconFile,
			V.[AllTabs],
			V.[Visibility],
			V.[IsDeleted],
			V.[Header],
			V.[Footer],
			V.[StartDate],
			V.[EndDate],
			V.[ContainerSrc],
			V.[DisplayTitle],
			V.[DisplayPrint],
			V.[DisplaySyndicate],
			V.[IsWebSlice],
			V.[WebSliceTitle],
			V.[WebSliceExpiryDate],
			V.[WebSliceTTL],
			V.[InheritViewPermissions],
			V.[IsShareable],
			V.[IsShareableViewOnly],
			V.[DesktopModuleID],
			V.[DefaultCacheTime],
			V.[ModuleControlID],
			V.[BusinessControllerClass],
			V.[IsAdmin],
			V.[SupportedFeatures],
			V.[PackageID],
			C.[ContentItemID],
			C.[Content],
			C.[ContentTypeID],
			C.[ContentKey],
			C.[Indexed],
			C.[StateID],
			V.[CreatedByUserID],
			V.[CreatedOnDate],
			V.[LastModifiedByUserID],
			V.[LastModifiedOnDate],
			V.[LastContentModifiedOnDate],
			V.[UniqueId],
			V.[VersionGuid],
			V.[DefaultLanguageGuid],
			V.[LocalizedVersionGuid],
			V.[CultureCode]
		FROM      {databaseOwner}[{objectQualifier}vw_ModulesOnTabs] V 
		LEFT JOIN {databaseOwner}[{objectQualifier}ContentItems]     C ON V.[ContentItemID] = C.[ContentItemID]
		WHERE V.[ModuleID] = @ModuleId
		  AND V.[TabID]    = @TabId
GO


CREATE PROCEDURE {databaseOwner}[{objectQualifier}GetModules]
	@PortalID 		Int	-- not Null
AS
	SELECT	
	    V.*,  
		{databaseOwner}[{objectQualifier}FilePath](V.IconFile) AS IconFile,
        CI.Content,
        CI.ContentTypeID,
        CI.ContentKey,
        CI.Indexed,
		CI.StateID	
	FROM      {databaseOwner}[{objectQualifier}vw_ModulesOnTabs] V  
	LEFT JOIN {databaseOwner}[{objectQualifier}ContentItems]     CI ON V.ContentItemID = CI.ContentItemID
	WHERE  PortalId = @PortalID
	ORDER BY PortalID, ModuleID, TabID
GO

CREATE PROCEDURE {databaseOwner}[{objectQualifier}GetModulePermissionsByTabID]
    @TabId Int -- Not Null!
AS
    SELECT 		
		P.ModulePermissionID,
        P.ModuleID,
        P.PortalID,
        P.PermissionID,
        P.RoleID,
		R.RoleName,
        P.AllowAccess,
        P.UserID,
		U.UserName,
		U.DisplayName,
        P.PermissionCode,
        P.ModuleDefID,
        P.PermissionKey,
        P.PermissionName,
        P.CreatedByUserID,
        P.CreatedOnDate,
        P.LastModifiedByUserID,
        P.LastModifiedOnDate
    FROM      {databaseOwner}[{objectQualifier}vw_ModulePermissionTabs] P 
	LEFT JOIN {databaseOwner}[{objectQualifier}Users]                   U ON P.UserID = U.UserID
	LEFT JOIN {databaseOwner}[{objectQualifier}Roles]                   R ON P.RoleID = R.RoleID
    WHERE P.TabID = @TabId
	ORDER BY ModuleID
GO


CREATE PROCEDURE {databaseOwner}[{objectQualifier}GetTabModuleSettingsByTab]
    @TabId Int
AS
BEGIN
	SELECT TabModuleID,
		   SettingName,
		   CASE WHEN Lower(SettingValue) LIKE 'fileid=%'
			    THEN {databaseOwner}{objectQualifier}FilePath(SettingValue)
			    ELSE SettingValue 
		   END  AS SettingValue
	 FROM  {databaseOwner}[{objectQualifier}vw_TabModuleSettings] 
	 WHERE TabID = @TabId
	 ORDER BY TabModuleID
END
GO

IF {databaseOwner}[{objectQualifier}sys_currentDNNVersion]() < 70300 Exec('
CREATE PROCEDURE {databaseOwner}[{objectQualifier}GetTabSettings]
    @TabId Int -- Null for all tabs
AS
BEGIN
	SET NOCOUNT ON;
	SELECT SettingName,
		   CASE WHEN Lower(SettingValue) Like ''fileid=%''
			 THEN {databaseOwner}[{objectQualifier}FilePath](SettingValue)
			 ELSE SettingValue 
		   END           AS SettingValue
	FROM   {databaseOwner}[{objectQualifier}TabSettings] 
	WHERE  (TabID = @TabId OR IsNull(@TabId, -1) = -1)
	OPTION (OPTIMIZE FOR (@TabId UNKNOWN));
	SET NOCOUNT OFF;
END
') ELSE Exec('
CREATE PROCEDURE {databaseOwner}[{objectQualifier}GetTabSettings]
    @PortalId Int -- Not Null
AS
BEGIN
	SET NOCOUNT ON;
	SELECT TabID,
		   SettingName,
		   CASE WHEN Lower(SettingValue) LIKE ''fileid=%''
			 THEN {databaseOwner}{objectQualifier}FilePath(SettingValue)
			 ELSE SettingValue 
		   END           			 AS SettingValue
	 FROM  {databaseOwner}[{objectQualifier}vw_TabSettings]
	 WHERE (PortalId = @PortalId)
	 ORDER BY TabID;
	SET NOCOUNT OFF;
END
')
GO


CREATE PROCEDURE {databaseOwner}[{objectQualifier}GetPortalDesktopModules]
	@PortalId        Int, -- Null|-1: all portals
	@DesktopModuleId Int  -- Null|-1: all modules
AS BEGIN
	SELECT *
	FROM {databaseOwner}[{objectQualifier}vw_PortalDesktopModules] 
	WHERE ((PortalId        = @PortalId       ) OR IsNull(@PortalId,        -1) = -1)
	  AND ((DesktopModuleId = @DesktopModuleId) OR IsNull(@DesktopModuleId, -1) = -1)
	ORDER BY PortalId, CultureCode, DesktopModuleId
END
GO


CREATE PROCEDURE {databaseOwner}[{objectQualifier}GetModulePackagesInUse]
    @PortalId Int,  -- Null|-1 for Host menu items
    @ForHost  Bit   -- 0: Get in use for portal or host only
                    -- 1: Get in use for all host pages and portal pages
AS
BEGIN
    SELECT * FROM {databaseOwner}[{objectQualifier}Packages]
     WHERE PackageID IN (SELECT DISTINCT PackageID
                          FROM  {databaseOwner}[{objectQualifier}vw_ModulesOnTabs]
                          WHERE (IsNull(PortalID, -1) = ISNull(@PortalId, -1) OR (@ForHost = 1)) -- scope
                            AND IsDeleted = 0)
    ORDER BY FriendlyName
	OPTION (OPTIMIZE FOR (@PortalId UNKNOWN));
END
GO


CREATE PROCEDURE {databaseOwner}[{objectQualifier}GetExtensionUrlProviders] 
	@PortalID	int -- Null|-1 for shared providers
AS
BEGIN
	SELECT 
		[ExtensionUrlProviderID],
		[ProviderName],
		[ProviderType],
		[SettingsControlSrc],
		[IsActive],
		[RewriteAllUrls],
		[RedirectAllUrls],
		[ReplaceAllUrls],
		[DesktopModuleId], 
		[PortalID]
	FROM  {databaseOwner}{objectQualifier}vw_ExtensionUrlProviders
	WHERE [PortalID] = IsNull(@PortalID, -1) OR [PortalID] IS Null

	SELECT ExtensionUrlProviderID, 
			PortalID, 
			SettingName, 
			SettingValue
	FROM  {databaseOwner}{objectQualifier}ExtensionUrlProviderSetting
	WHERE [PortalID] = IsNull(@PortalID, -1)

	SELECT DISTINCT 
		P.[ExtensionUrlProviderID],
		M.[TabID]
	FROM       {databaseOwner}{objectQualifier}vw_ExtensionUrlProviders P
	INNER JOIN {databaseOwner}{objectQualifier}vw_ModulesOnTabs         M ON M.[DesktopModuleID] = P.[DesktopModuleID]
	WHERE      (P.[PortalID] = IsNull(@PortalID, -1)) OR (P.[PortalID] IS Null)	  
	UNION
	SELECT  
		P.[ExtensionUrlProviderID],
		T.[TabId]
	FROM       {databaseOwner}{objectQualifier}ExtensionUrlProviderTab T
	INNER JOIN {databaseOwner}{objectQualifier}ExtensionUrlProviders   P ON P.[ExtensionUrlProviderID] = T.[ExtensionUrlProviderID]
	WHERE   (T.[IsActive] = 1)
END
GO

-- use optimized query
IF {databaseOwner}[{objectQualifier}sys_currentDNNVersion]() < 70200 Exec ('
CREATE PROCEDURE {databaseOwner}[{objectQualifier}GetSearchItems]
	@PortalID Int, -- Null for all
	@TabId    Int, -- Null for all
	@ModuleId Int  -- Null for all
AS
BEGIN
	SELECT
        S.SearchItemID, 
        S.ModuleID, 
        S.Title, 
        S.[Description], 
        S.Author, 
        S.PubDate, 
        S.SearchKey, 
        S.[Guid], 
        S.HitCount, 
        S.ImageFileId, 
        U.DisplayName AS AuthorName
	FROM      {databaseOwner}[{objectQualifier}vw_SearchItemBase] S
	LEFT JOIN {databaseOwner}[{objectQualifier}Users]             U ON S.Author = U.UserID
	WHERE (PortalId = @PortalID OR @PortalID IS Null)
	  AND (TabId    = @TabId    OR @TabId    IS Null)
	  AND (ModuleId = @ModuleId OR @ModuleId IS Null)
	ORDER BY PubDate DESC
END
')
GO

IF {databaseOwner}[{objectQualifier}sys_currentDNNVersion]() < 70200 Exec ('
CREATE PROCEDURE {databaseOwner}[{objectQualifier}GetSearchResults]
	@PortalID Int, -- Null for all
	@TabId    Int, -- Null for all
	@ModuleId Int  -- Null for all
AS
BEGIN
	SELECT S.*, 
           U.DisplayName AS AuthorName
	FROM      {databaseOwner}{objectQualifier}vw_SearchItemBase  S
	LEFT JOIN {databaseOwner}{objectQualifier}Users              U ON S.Author = U.UserID
	WHERE (PortalId = @PortalID OR @PortalID IS Null)
	  AND (TabId    = @TabId    OR @TabId    IS Null)
	  AND (ModuleId = @ModuleId OR @ModuleId IS Null)
	ORDER BY PubDate DESC
END
')
GO

CREATE PROCEDURE {databaseOwner}[{objectQualifier}GetPortalRoles]
    @PortalId     Int -- Null: Host Roles
AS
BEGIN
    SELECT R.*,
           C.UserCount
     FROM      {databaseOwner}[{objectQualifier}Roles]         R
	 LEFT JOIN {databaseOwner}[{objectQualifier}vw_RoleUserCount] C ON R.RoleID = C.RoleID
     WHERE (PortalId = @PortalId OR PortalId is Null)
       AND (R.RoleId >= 0) -- DNN-4288: hide system role atm to prevent duplicates. Might be removed, after API has been adopt
     ORDER BY RoleName
	OPTION (OPTIMIZE FOR (@PortalId UNKNOWN));
END
GO


CREATE PROCEDURE {databaseOwner}[{objectQualifier}GetRoles]
AS
BEGIN
    SELECT R.*,
           C.UserCount
     FROM      {databaseOwner}[{objectQualifier}Roles] AS R
	 LEFT JOIN {databaseOwner}[{objectQualifier}vw_RoleUserCount] AS C ON R.RoleID = C.RoleID
     WHERE R.RoleID >= 0; -- ignore virtual roles. Note: might be removed, after controller has been adjusted
END
GO


CREATE PROCEDURE {databaseOwner}[{objectQualifier}GetRolesByUser]
    @UserId        Int, -- not Null!
    @PortalId      Int  -- not Null!
AS
BEGIN
    SELECT RoleName,
           RoleID
    FROM {databaseOwner}[{objectQualifier}Vw_UserRoles] 
    WHERE  (UserID   = @UserId)
      AND  (PortalID = @PortalId)
      AND  (IsNull(EffectiveDate, GetDate()) <= GetDate())
      AND  (IsNull(ExpiryDate,    GetDate()) >= GetDate())
END
GO


CREATE PROCEDURE {databaseOwner}[{objectQualifier}GetUserRolesByUsername]
    @PortalID Int,            -- not Null!
    @Username nVarChar(100),  -- Null for all user-role combinations
    @Rolename nVarChar( 50)   -- Null for all Roles
AS
BEGIN
	-- handle branches individually for performance
	IF IsNull(@UserName, '') = ''
		IF ISNull(@RoleName, '') = ''
			SELECT * FROM {databaseOwner}[{objectQualifier}vw_UserRoles] 
			 WHERE (PortalId = @PortalId)
		ELSE
 			SELECT * FROM {databaseOwner}[{objectQualifier}vw_UserRoles] 
			 WHERE (PortalId = @PortalId) AND (Rolename = @Rolename)
    ELSE
		IF ISNull(@RoleName, '') = ''
			SELECT * FROM {databaseOwner}[{objectQualifier}vw_UserRoles] 
			 WHERE (PortalId = @PortalId) AND (Username = @Username)
		ELSE
			SELECT * FROM {databaseOwner}[{objectQualifier}vw_UserRoles] 
			 WHERE (PortalId = @PortalId) AND (Username = @Username) AND (Rolename = @Rolename)
END
GO


CREATE PROCEDURE {databaseOwner}[{objectQualifier}GetUserRole]
	@PortalID int, 
	@UserID int, 
	@RoleId int
AS
BEGIN
	SELECT	*
    FROM  {databaseOwner}[{objectQualifier}vw_UserRoles] 
    WHERE  UserId   = @UserID
      AND  PortalId = @PortalID
	  AND  RoleId   = @RoleId
END
GO


CREATE PROCEDURE {databaseOwner}[{objectQualifier}GetUserRoles]
	@PortalId  int,
	@UserId    int
AS
BEGIN
	SELECT *
	FROM {databaseOwner}[{objectQualifier}vw_UserRoles] 
	WHERE UserID = @UserId AND PortalID = @PortalId
END
GO


CREATE PROCEDURE {databaseOwner}[{objectQualifier}GetUserCountByPortal]
	@PortalId Int -- Not Null
AS
BEGIN
	SET NOCOUNT ON;
	SELECT UserCount
	 FROM  {databaseOwner}[{objectQualifier}vw_RoleUserCount]
	 WHERE RoleID IN (SELECT RegisteredRoleId FROM {databaseOwner}[{objectQualifier}Portals] WHERE PortalID  = @PortalID);
	SET NOCOUNT OFF;
END
GO


CREATE PROCEDURE {databaseOwner}[{objectQualifier}CoreMessaging_GetMessageThread]
    @ConversationID  Int,							 -- Not Null!
	@UserID 		 Int,							 -- Not Null!
	@AfterMessageID  Int,							 -- Null|<= 0 for all
	@NumberOfRecords Int,							 -- Not Null, must be > 0!
	@SortField 		 nVarChar(25) = 'CreatedOnDate', -- Not Null, only 'CreatedOnDate', 'From' or 'Subject'
	@SortAscending 	 Bit          = 0                -- Not Null, 1: ascending, 0: descending
AS
BEGIN
	--Cannot return thread if user was not a recipient
	IF NOT EXISTS (SELECT (1)
				   FROM {databaseOwner}[{objectQualifier}vw_CoreMessaging_Messages]
				   WHERE [UserID] = @UserID AND [NotificationTypeID] IS Null) BEGIN
		SELECT 0;
		RETURN;
	END;

	WITH inboxItems AS
	(   SELECT 
			m.[RecipientID], 
			m.[Subject], 
			m.[Body], 
			m.[SenderUserID],
			m.[Read], 
			m.[Archived], 
			m.[UserID], 
			m.[To], 
			m.[From], 
			m.[ReplyAllAllowed], 
			m.[ConversationID],
			m.[MessageID],
			m.[CreatedByUserID],
			m.[CreatedOnDate],
			m.[LastModifiedByUserID],
			m.[LastModifiedOnDate],
			(SELECT COUNT(*) FROM {databaseOwner}{objectQualifier}CoreMessaging_MessageAttachments WHERE MessageID = m.MessageID) AS AttachmentCount,
			(SELECT COUNT(*) FROM {databaseOwner}{objectQualifier}CoreMessaging_MessageRecipients  WHERE MessageID IN (SELECT MessageID FROM {databaseOwner}{objectQualifier}CoreMessaging_Messages WHERE ConversationID = m.ConversationID) AND UserID = @UserID AND [READ] = 0) AS NewThreadCount,
			(SELECT COUNT(*) FROM {databaseOwner}{objectQualifier}CoreMessaging_MessageRecipients  WHERE MessageID IN (SELECT MessageID FROM {databaseOwner}{objectQualifier}CoreMessaging_Messages WHERE ConversationID = m.ConversationID) AND UserID = @UserID) AS ThreadCount,
			ROW_NUMBER() OVER 
			    (ORDER BY
				 CASE WHEN @SortField = 'CreatedOnDate' AND @SortAscending = 1 THEN m.[CreatedOnDate] END ASC,
				 CASE WHEN @SortField = 'CreatedOnDate' AND @SortAscending = 0 THEN m.[CreatedOnDate] END DESC,
				 CASE WHEN @SortField = 'From'          AND @SortAscending = 1 THEN m.[From]          END ASC,
				 CASE WHEN @SortField = 'From'          AND @SortAscending = 0 THEN m.[From]          END DESC,
				 CASE WHEN @SortField = 'Subject'       AND @SortAscending = 1 THEN m.[Subject]       END ASC,
				 CASE WHEN @SortField = 'Subject'       AND @SortAscending = 0 THEN m.[Subject]       END DESC
				) AS RowNumber
		FROM {databaseOwner}[{objectQualifier}vw_CoreMessaging_Messages] AS m 
		WHERE m.ConversationID = @ConversationID
		  AND m.UserID      = @UserID
	)
	SELECT * FROM inboxItems
	WHERE (IsNull(@AfterMessageID, -1) > 0 AND RowNumber BETWEEN (SELECT RowNumber + 1 FROM inboxItems WHERE [MessageID] = @AfterMessageID) 
											  AND (SELECT RowNumber + @NumberOfRecords FROM inboxItems WHERE [MessageID] = @AfterMessageID)) 
	   OR (IsNull(@AfterMessageID, -1) < 1 AND RowNumber BETWEEN 1 AND @NumberOfRecords)
	ORDER BY RowNumber ASC;
END
GO


CREATE PROCEDURE {databaseOwner}[{objectQualifier}CoreMessaging_GetMessageConversations]
	@UserID 		 Int,							 -- Not Null!
	@PortalID 		 Int,							 -- Not Null!
	@AfterMessageID  Int,							 -- Null|<= 0 for all
	@NumberOfRecords Int,							 -- Not Null, must be > 0!
	@SortField 		 nVarChar(25) = 'CreatedOnDate', -- Not Null, only 'CreatedOnDate', 'From' or 'Subject'
	@SortAscending 	 Bit          = 0,               -- Not Null, 1: ascending, 0: descending
	@Read 			 Bit          = 0,				 -- Read messages only: 1: read only, 0: unread only, Null: both
	@Archived 		 Bit 		  = 0,				 -- Archived messages only (1: archived, 0: new,  Null for all)
	@SentOnly 		 Bit 		  = 0				 -- Sent messages only (1: sent, 0 | Null for all)
AS
BEGIN
	--Get the top message for each conversation
	WITH RollUpMessageIDs AS
	(  SELECT MAX(MessageID) AS TopMessageID
		FROM  {databaseOwner}[{objectQualifier}vw_CoreMessaging_Messages]
		WHERE (([Archived] = @Archived) OR (@Archived is null))
		  AND (([Read]     = @Read    ) OR (@Read     is null)) 
		  AND ((IsNull(@SentOnly, 0) = 1 AND SenderUserID = @UserID) OR (IsNull(@SentOnly, 0) = 0 AND UserID = @UserID))
		  AND NotificationTypeID IS NULL 
		  AND PortalID = @PortalID
		GROUP BY ConversationID
	)
	,Conversations AS
	(   SELECT 
			[MessageID], 
			[ConversationID], 
			[Subject], 
			Convert(nvarchar(50), [Body]) AS Body,
			[To], 
			[From], 
			[ReplyAllAllowed], 
			[SenderUserID],
			[CreatedByUserID], 
			[CreatedOnDate],
			[LastModifiedByUserID], 
			[LastModifiedOnDate],
			(SELECT COUNT(*) FROM {databaseOwner}{objectQualifier}CoreMessaging_MessageAttachments WHERE MessageID IN (SELECT MessageID FROM {databaseOwner}{objectQualifier}CoreMessaging_Messages WHERE ConversationID = m.ConversationID)) AS AttachmentCount,
			(SELECT COUNT(*) FROM {databaseOwner}{objectQualifier}CoreMessaging_MessageRecipients  WHERE MessageID IN (SELECT MessageID FROM {databaseOwner}{objectQualifier}CoreMessaging_Messages WHERE ConversationID = m.ConversationID) AND UserID = @UserID AND [READ] = 0) AS NewThreadCount,
			(SELECT COUNT(*) FROM {databaseOwner}{objectQualifier}CoreMessaging_MessageRecipients  WHERE MessageID IN (SELECT MessageID FROM {databaseOwner}{objectQualifier}CoreMessaging_Messages WHERE ConversationID = m.ConversationID) AND UserID = @UserID) AS ThreadCount,
			ROW_NUMBER() OVER 
			    (ORDER BY
				 CASE WHEN @SortField = 'CreatedOnDate' AND @SortAscending = 1 THEN [CreatedOnDate] END ASC,
				 CASE WHEN @SortField = 'CreatedOnDate' AND @SortAscending = 0 THEN [CreatedOnDate] END DESC,
				 CASE WHEN @SortField = 'From'          AND @SortAscending = 1 THEN [From]          END ASC,
				 CASE WHEN @SortField = 'From'          AND @SortAscending = 0 THEN [From]          END DESC,
				 CASE WHEN @SortField = 'Subject'       AND @SortAscending = 1 THEN [Subject]       END ASC,
				 CASE WHEN @SortField = 'Subject'       AND @SortAscending = 0 THEN [Subject]       END DESC
				) AS RowNumber
		FROM {databaseOwner}{objectQualifier}CoreMessaging_Messages AS m
		WHERE MessageID IN (SELECT TopMessageID FROM RollUpMessageIDs)
	)
	SELECT * FROM Conversations
	WHERE (IsNull(@AfterMessageID, -1) > 0 AND RowNumber BETWEEN (SELECT RowNumber + 1 FROM Conversations WHERE [MessageID] = @AfterMessageID)
											  AND (SELECT RowNumber + @NumberOfRecords FROM Conversations WHERE [MessageID] = @AfterMessageID)) 
	   OR (IsNull(@AfterMessageID, -1) < 1 AND RowNumber BETWEEN 1 AND @NumberOfRecords)
	ORDER BY RowNumber ASC
END
GO


CREATE PROCEDURE {databaseOwner}[{objectQualifier}CoreMessaging_GetArchiveBox]
	@UserID 		 Int,							 -- Not Null!
	@PortalID 		 Int,							 -- Not Null!
	@AfterMessageID  Int,							 -- Null|<= 0 for all
	@NumberOfRecords Int,							 -- Not Null, must be > 0!
	@SortField 		 nVarChar(25) = 'CreatedOnDate', -- Not Null, only 'CreatedOnDate', 'From' or 'Subject'
	@SortAscending 	 Bit          = 0                -- Not Null, 1: ascending, 0: descending
AS
BEGIN
	WITH RollUpMessageIDs AS
	(	SELECT MAX(MessageID) AS TopMessageID
		FROM {databaseOwner}[{objectQualifier}vw_CoreMessaging_Messages]
		WHERE NotificationTypeID IS NULL AND PortalID = @PortalID AND UserID = @UserID AND Archived = 1
		GROUP BY ConversationID
	),
	ArchiveBox AS
	(	SELECT 
			[MessageID], 
			[ConversationID], 
			[Subject], 
			Convert(nvarchar(50), m.[Body]) AS Body,
			[To], 
			[From], 
			[ReplyAllAllowed], 
			[SenderUserID],
			[CreatedByUserID], 
			[CreatedOnDate],
			[LastModifiedByUserID], 
			[LastModifiedOnDate],
			(SELECT COUNT(*) FROM {databaseOwner}[{objectQualifier}CoreMessaging_MessageAttachments] WHERE MessageID = m.MessageID) AS AttachmentCount,
			(SELECT COUNT(*) FROM {databaseOwner}[{objectQualifier}CoreMessaging_MessageRecipients]  WHERE MessageID IN (SELECT MessageID FROM {databaseOwner}[{objectQualifier}CoreMessaging_Messages] WHERE ConversationID = m.ConversationID) AND UserID = @UserID AND [READ] = 0) AS NewThreadCount,
			(SELECT COUNT(*) FROM {databaseOwner}[{objectQualifier}CoreMessaging_MessageRecipients]  WHERE MessageID IN (SELECT MessageID FROM {databaseOwner}[{objectQualifier}CoreMessaging_Messages] WHERE ConversationID = m.ConversationID) AND UserID = @UserID) AS ThreadCount,
			ROW_NUMBER() OVER 
			    (ORDER BY PortalID, NotificationTypeID,
				 CASE WHEN @SortField = 'CreatedOnDate' AND @SortAscending = 1 THEN [CreatedOnDate] END ASC,
				 CASE WHEN @SortField = 'CreatedOnDate' AND @SortAscending = 0 THEN [CreatedOnDate] END DESC,
				 CASE WHEN @SortField = 'From'          AND @SortAscending = 1 THEN [From]          END ASC,
				 CASE WHEN @SortField = 'From'          AND @SortAscending = 0 THEN [From]          END DESC,
				 CASE WHEN @SortField = 'Subject'       AND @SortAscending = 1 THEN [Subject]       END ASC,
				 CASE WHEN @SortField = 'Subject'       AND @SortAscending = 0 THEN [Subject]       END DESC
				) AS RowNumber
		FROM  {databaseOwner}[{objectQualifier}CoreMessaging_Messages] m
		WHERE m.MessageID IN (SELECT TopMessageID FROM RollUpMessageIDs)
	)
	SELECT * FROM ArchiveBox
	WHERE (IsNull(@AfterMessageID, -1) > 0 AND RowNumber BETWEEN (SELECT RowNumber + 1 FROM ArchiveBox WHERE [MessageID] = @AfterMessageID) 
	                                          AND (SELECT RowNumber + @NumberOfRecords FROM ArchiveBox WHERE [MessageID] = @AfterMessageID)) 
	   OR (IsNull(@AfterMessageID, -1) < 1 AND RowNumber BETWEEN 1 AND @NumberOfRecords)
	ORDER BY RowNumber ASC
END
GO


CREATE PROCEDURE {databaseOwner}[{objectQualifier}CoreMessaging_CreateMessageRecipientsForRole]
    @MessageID int,         -- message id
    @RoleIDs nvarchar(max), -- comma separated list of RoleIds
	@CreateUpdateUserID INT -- create / update user id
AS
BEGIN    
    WITH CTE_RoleIDs(RowNumber, RowValue)
    AS
    (SELECT * FROM {databaseOwner}[{objectQualifier}ConvertListToTable](',', @RoleIDs)),
	CTE_DistinctUserIDs(UserID)
    AS (SELECT DISTINCT UserID
	    FROM {databaseOwner}[{objectQualifier}vw_UserRoles] ur 
        INNER JOIN CTE_RoleIDs cr ON ur.RoleID = cr.RowValue
	   )

    INSERT INTO {databaseOwner}[{objectQualifier}CoreMessaging_MessageRecipients](
		[MessageID],
		[UserID],
		[Read],
		[Archived],
		[CreatedByUserID],
		[CreatedOnDate],
		[LastModifiedByUserID],
		[LastModifiedOnDate]
		)
	SELECT
		@MessageID,
		UserID,
		0,
		0,
		@CreateUpdateUserID , -- CreatedBy - int
		GETDATE(), 			  -- CreatedOn - datetime
		@CreateUpdateUserID , -- LastModifiedBy - int
		GETDATE() 			  -- LastModifiedOn - datetime
	FROM CTE_DistinctUserIDs
END
GO


CREATE PROCEDURE {databaseOwner}[{objectQualifier}CoreMessaging_CountNewThreads]
	@UserID   Int, -- Not Null
	@PortalID Int  -- Not Null
AS
BEGIN
	SELECT COUNT(1) AS TotalNewThreads
	FROM  {databaseOwner}[{objectQualifier}vw_CoreMessaging_Recipients] 
	WHERE PortalID = @PortalID 
	  AND UserID   = @UserID
	  AND [Read]   = 0
	  AND NotificationTypeID IS NULL
END
GO


IF ({databaseOwner}[{objectQualifier}sys_currentDNNVersion]() >= 70200) Exec('
CREATE PROCEDURE {databaseOwner}{objectQualifier}CoreMessaging_CheckReplyHasRecipients
	@ConversationId Int, -- Not Null
	@UserId 		Int  -- Not Null
AS 
BEGIN
	SELECT COUNT(1) N
	FROM       {databaseOwner}[{objectQualifier}vw_CoreMessaging_Messages] AS M 
	INNER JOIN {databaseOwner}[{objectQualifier}vw_Users] AS U ON M.UserID = U.UserID AND M.PortalID = IsNull(U.PortalID, M.PortalID)
	WHERE (M.MessageID = @ConversationId) 
	  AND (M.UserID   <> @UserId) 
	  AND (U.IsDeleted = 0)
END')
GO

IF {databaseOwner}[{objectQualifier}sys_currentDNNVersion]() >= 70300 EXEC ('
CREATE PROCEDURE {databaseOwner}[{objectQualifier}Journal_Get]
	@PortalId 			Int, 	 -- not Null
	@CurrentUserId 		Int, 	 -- not Null
	@JournalId 			Int,	 -- Not Null, > 0
	@IncludeAllItems 	Bit = 0, -- 0: deleted/not deleted only, 1: ignore @isDeleted (tristate @isDeleted (1, 0, Null) would be easier)
	@IsDeleted 			Bit = 0, -- 1: deleted only, 0: active only
    @SecurityCheck 		Bit = 0  -- 0: all items, 1: journal items only, the currentUser is permitted to view
AS
BEGIN
	SET NOCOUNT ON;
	IF @SecurityCheck = 0
		SELECT  
			J.JournalId, 
			J.JournalTypeId, 
			J.Title, 
			J.Summary, 
			J.UserId, 
			J.DateCreated, 
			J.DateUpdated, 
			J.PortalId,
			J.ProfileId, 
			J.GroupId, 
			J.ObjectKey, 
			J.AccessKey,
			{databaseOwner}[{objectQualifier}Journal_XMLEntityNode](J.ProfileId, P.DisplayName) AS JournalOwner,
			{databaseOwner}[{objectQualifier}Journal_XMLEntityNode](J.UserId,    U.DisplayName) AS JournalAuthor,
			IsNull(J.ProfileId, J.UserId) AS JournalOwnerId,
			J.Icon, 
			J.JournalType,
			{databaseOwner}[{objectQualifier}Journal_XMLEntityNode](J.ProfileId, P.DisplayName) AS Profile,
			J.JournalXML, 
			J.ContentItemId, 
			J.ItemData, 
			J.IsDeleted, 
			J.CommentsDisabled, 
			J.CommentsHidden
		FROM       {databaseOwner}[{objectQualifier}vw_JournalItems]  AS J
		INNER JOIN {databaseOwner}[{objectQualifier}Journal_PermittedJournalIDs](@PortalId, @CurrentUserId) S ON J.JournalID = S.JournalID
		LEFT  JOIN {databaseOwner}[{objectQualifier}Users] U          ON J.UserID = U.UserID
		LEFT  JOIN {databaseOwner}[{objectQualifier}Users] P          ON J.ProfileID = P.UserID
		WHERE (J.JournalId = @JournalId)
		  AND (@IncludeAllItems = 1 OR J.IsDeleted = @IsDeleted);
	ELSE 
		SELECT  
			J.JournalId, 
			J.JournalTypeId, 
			J.Title, 
			J.Summary, 
			J.UserId, 
			J.DateCreated, 
			J.DateUpdated, 
			J.PortalId,
			J.ProfileId, 
			J.GroupId, 
			J.ObjectKey, 
			J.AccessKey,
			{databaseOwner}[{objectQualifier}Journal_XMLEntityNode](J.ProfileId, P.DisplayName) AS JournalOwner,
			{databaseOwner}[{objectQualifier}Journal_XMLEntityNode](J.UserId,    U.DisplayName) AS JournalAuthor,
			IsNull(J.ProfileId, J.UserId) AS JournalOwnerId,
			J.Icon, 
			J.JournalType,
			{databaseOwner}[{objectQualifier}Journal_XMLEntityNode](J.ProfileId, P.DisplayName) AS Profile,
			J.JournalXML, 
			J.ContentItemId, 
			J.ItemData, 
			J.IsDeleted, 
			J.CommentsDisabled, 
			J.CommentsHidden
		FROM       {databaseOwner}[{objectQualifier}vw_JournalItems]  AS J
		LEFT  JOIN {databaseOwner}[{objectQualifier}Users] U          ON J.UserID = U.UserID
		LEFT  JOIN {databaseOwner}[{objectQualifier}Users] P          ON J.ProfileID = P.UserID
		WHERE (J.JournalId = @JournalId)
		  AND (@IncludeAllItems = 1 OR J.IsDeleted = @IsDeleted);

		SET NOCOUNT OFF;
END
') ELSE EXEC('
CREATE PROCEDURE {databaseOwner}[{objectQualifier}Journal_Get]
	@PortalId 			Int, 	 -- not Null
	@CurrentUserId 		Int, 	 -- not Null
	@JournalId 			Int,	 -- Not Null, > 0
	@IncludeAllItems 	Bit = 0, -- 0: deleted/not deleted only, 1: ignore @isDeleted (tristate @isDeleted (1, 0, Null) would be easier)
	@IsDeleted 			Bit = 0  -- 1: deleted only, 0: active only
AS
BEGIN
	SET NOCOUNT ON;
	SELECT  J.JournalId, 
			J.JournalTypeId, 
			J.Title, 
			J.Summary, 
			J.UserId, 
			J.DateCreated, 
			J.DateUpdated, 
			J.PortalId,
			J.ProfileId, 
			J.GroupId, 
			J.ObjectKey, 
			J.AccessKey,
			{databaseOwner}[{objectQualifier}Journal_XMLEntityNode](J.ProfileId, P.DisplayName) AS JournalOwner,
			{databaseOwner}[{objectQualifier}Journal_XMLEntityNode](J.UserId,    U.DisplayName) AS JournalAuthor,
			ISNULL(J.ProfileId, J.UserId) AS JournalOwnerId,
			J.Icon, 
			J.JournalType,
			{databaseOwner}[{objectQualifier}Journal_XMLEntityNode](J.ProfileId, P.DisplayName) AS Profile,
			J.JournalXML, 
			J.ContentItemId, 
			J.ItemData, 
			J.IsDeleted, 
			J.CommentsDisabled, 
			J.CommentsHidden
	FROM       {databaseOwner}[{objectQualifier}vw_JournalItems] AS J
	LEFT  JOIN {databaseOwner}[{objectQualifier}Users] U ON J.UserID = U.UserID
	LEFT  JOIN {databaseOwner}[{objectQualifier}Users] P ON J.ProfileID = P.UserID
    WHERE (J.JournalId = @JournalId)
	  AND (@IncludeAllItems = 1 OR J.IsDeleted = @IsDeleted);
	SET NOCOUNT OFF;
END
')
GO

CREATE PROCEDURE {databaseOwner}[{objectQualifier}Journal_GetStatsForGroup]
	@PortalId 	Int, -- Not Null
	@GroupId 	Int  -- Not Null
AS
	SELECT Count(JournalTypeId) AS JournalTypeCount, 
		   JournalType 
	FROM       {databaseOwner}[{objectQualifier}vw_JournalBase] 
	WHERE GroupId   = @GroupId
	  AND PortalId  = @PortalId 
	  AND IsDeleted = 0
	GROUP BY JournalType
GO


IF {databaseOwner}[{objectQualifier}sys_currentDNNVersion]() >= 70302 EXEC ('
CREATE PROCEDURE {databaseOwner}[{objectQualifier}Journal_ListForGroup]
	@PortalId		 Int,  -- Not Null
	@ModuleId		 Int,  -- Not Null
	@CurrentUserId	 Int,
	@GroupId		 Int,
	@RowIndex		 Int,
	@MaxRows 		 Int,
	@IncludeAllItems Int = 0,
	@IsDeleted 		 Int = 0
AS
BEGIN
	SET NOCOUNT ON;
	DECLARE @EndRow Int = @RowIndex + @MaxRows;
	
	WITH JournalItems AS (
		SELECT JournalId, 
			   ROW_NUMBER() OVER (ORDER BY JournalId DESC) AS RowNumber
		 FROM  {databaseOwner}[{objectQualifier}Journal_PermittedJournalIDs](@PortalId, @CurrentUserId)
		 WHERE PortalId = @PortalId
		   AND GroupId  = @GroupId
		   AND JournalTypeId IN (SELECT JournalTypeId FROM {databaseOwner}[{objectQualifier}Journal_ValidJournalTypesForModule](@ModuleId))		
		   AND (@IncludeAllItems = 1 or isDeleted = @isDeleted)
	) SELECT	
			J.JournalId, 
			J.JournalTypeId, 
			J.Title, 
			J.Summary, 
			J.UserId, 
			J.DateCreated, 
			J.DateUpdated, 
			J.PortalId,
			J.ProfileId, 
			J.GroupId, 
			J.ObjectKey, 
			J.AccessKey,
			{databaseOwner}[{objectQualifier}Journal_XMLEntityNode](J.GroupId,   R.RoleName   ) AS JournalOwner,
			{databaseOwner}[{objectQualifier}Journal_XMLEntityNode](J.UserId,    U.DisplayName) AS JournalAuthor,
			IsNull(J.ProfileId, J.UserId) AS JournalOwnerId,
			J.Icon, 
			J.JournalType,
			{databaseOwner}[{objectQualifier}Journal_XMLEntityNode](J.ProfileId, P.DisplayName) AS Profile,
			(SELECT COUNT(JournalId) FROM {databaseOwner}[{objectQualifier}Journal] WHERE ContentItemId = j.ContentItemId AND JournalTypeId = j.JournalTypeId) AS SimilarCount,
			J.JournalXML, 
			J.ContentItemId, 
			J.ItemData, 
			JI.RowNumber, 
			J.IsDeleted, 
			J.CommentsDisabled, 
			J.CommentsHidden
	FROM		JournalItems 									  JI
	INNER JOIN  {databaseOwner}[{objectQualifier}vw_JournalItems] J  ON J.JournalId = JI.JournalId
	LEFT  JOIN  {databaseOwner}[{objectQualifier}Users]           U  ON J.UserID    = U.UserID
	LEFT  JOIN  {databaseOwner}[{objectQualifier}Users]           P  ON J.ProfileID = P.UserID
	LEFT  JOIN  {databaseOwner}[{objectQualifier}Roles]           R  ON J.GroupId   = R.RoleID
	WHERE		(RowNumber BETWEEN @RowIndex AND @EndRow)
	ORDER BY RowNumber ASC;
	SET NOCOUNT OFF;
END
') ELSE Exec('
CREATE PROCEDURE {databaseOwner}[{objectQualifier}Journal_ListForGroup]
	@PortalId		 Int,  -- Not Null
	@ModuleId		 Int,  -- Not Null
	@CurrentUserId	 Int,
	@GroupId		 Int,
	@RowIndex		 Int,
	@MaxRows 		 Int,
	@IncludeAllItems Int = 0,
	@IsDeleted 		 Int = 0
AS
BEGIN
	SET NOCOUNT ON;
	DECLARE @EndRow Int = @RowIndex + @MaxRows;
	
	WITH JournalItems AS (
		SELECT JournalId, 
			   ROW_NUMBER() OVER (ORDER BY JournalId DESC) AS RowNumber
		 FROM  {databaseOwner}[{objectQualifier}Journal_PermittedJournalIDs](@PortalId, @CurrentUserId)
		 WHERE PortalId = @PortalId
		   AND GroupId  = @GroupId
		   AND JournalTypeId IN (SELECT JournalTypeId FROM {databaseOwner}[{objectQualifier}Journal_ValidJournalTypesForModule](@ModuleId))		
		   AND (@IncludeAllItems = 1 or isDeleted = @isDeleted)
	) SELECT	
			J.JournalId, 
			J.JournalTypeId, 
			J.Title, 
			J.Summary, 
			J.UserId, 
			J.DateCreated, 
			J.DateUpdated, 
			J.PortalId,
			J.ProfileId, 
			J.GroupId, 
			J.ObjectKey, 
			J.AccessKey,
			{databaseOwner}[{objectQualifier}Journal_XMLEntityNode](J.GroupId,   R.RoleName   ) AS JournalOwner,
			{databaseOwner}[{objectQualifier}Journal_XMLEntityNode](J.UserId,    U.DisplayName) AS JournalAuthor,
			IsNull(J.ProfileId, J.UserId) AS JournalOwnerId,
			J.Icon, 
			J.JournalType,
			{databaseOwner}[{objectQualifier}Journal_XMLEntityNode](J.ProfileId, P.DisplayName) AS Profile,
			J.JournalXML, 
			J.ContentItemId, 
			J.ItemData, 
			JI.RowNumber, 
			J.IsDeleted, 
			J.CommentsDisabled, 
			J.CommentsHidden
	FROM		JournalItems 									  JI
	INNER JOIN  {databaseOwner}[{objectQualifier}vw_JournalItems] J  ON J.JournalId = JI.JournalId
	LEFT  JOIN  {databaseOwner}[{objectQualifier}Users]           U  ON J.UserID    = U.UserID
	LEFT  JOIN  {databaseOwner}[{objectQualifier}Users]           P  ON J.ProfileID = P.UserID
	LEFT  JOIN  {databaseOwner}[{objectQualifier}Roles]           R  ON J.GroupId   = R.RoleID
	WHERE		(RowNumber BETWEEN @RowIndex AND @EndRow)
	ORDER BY RowNumber ASC;
	SET NOCOUNT OFF;
END
')
GO



IF {databaseOwner}[{objectQualifier}sys_currentDNNVersion]() >= 70302 EXEC ('
CREATE PROCEDURE {databaseOwner}[{objectQualifier}Journal_ListForSummary]
	@PortalId 			Int,
	@ModuleId 			Int,
	@CurrentUserId 		Int,
	@RowIndex 			Int,
	@MaxRows 			Int,
	@IncludeAllItems 	Int = 0,
	@IsDeleted 			Int = 0	
AS
BEGIN
	IF @RowIndex = 0 SET @RowIndex = 1 -- this is not best practice, IMHO
	
	DECLARE @EndRow Int  = @RowIndex + @MaxRows - 1;
	
	WITH JournalItems AS (
		SELECT JournalId, 
			   ROW_NUMBER() OVER (ORDER BY JournalId DESC) AS RowNumber
		 FROM  {databaseOwner}[{objectQualifier}Journal_PermittedJournalIDs](@PortalId, @CurrentUserId) 
		 WHERE PortalId = @PortalId
		   AND JournalTypeId IN (SELECT JournalTypeId FROM {databaseOwner}[{objectQualifier}Journal_ValidJournalTypesForModule](@ModuleId))		
		   AND (@IncludeAllItems = 1 or isDeleted = @isDeleted)
	) SELECT	
			J.JournalId, 
			J.JournalTypeId, 
			J.Title, 
			J.Summary, 
			J.UserId, 
			J.DateCreated, 
			J.DateUpdated, 
			J.PortalId,
			J.ProfileId, 
			J.GroupId, 
			J.ObjectKey, 
			J.AccessKey,
			{databaseOwner}[{objectQualifier}Journal_XMLEntityNode](J.ProfileId, P.DisplayName) AS JournalOwner,
			{databaseOwner}[{objectQualifier}Journal_XMLEntityNode](J.UserId,    U.DisplayName) AS JournalAuthor,
			IsNull(J.ProfileId, J.UserId) AS JournalOwnerId,
			J.Icon, 
			J.JournalType,
			{databaseOwner}[{objectQualifier}Journal_XMLEntityNode](J.ProfileId, P.DisplayName) AS Profile,
			(SELECT COUNT(JournalId) FROM {databaseOwner}[{objectQualifier}Journal] WHERE ContentItemId = j.ContentItemId AND JournalTypeId = j.JournalTypeId) AS SimilarCount,
			J.JournalXML, 
			J.ContentItemId, 
			J.ItemData, 
			RowNumber, 
			J.IsDeleted, 
			J.CommentsDisabled, 
			J.CommentsHidden
	FROM	   JournalItems 									 JI
	INNER JOIN {databaseOwner}[{objectQualifier}vw_JournalItems] J  ON J.JournalId = JI.JournalId 
	LEFT  JOIN {databaseOwner}[{objectQualifier}Users]           U  ON J.UserID    = U.UserID
	LEFT  JOIN {databaseOwner}[{objectQualifier}Users]           P  ON J.ProfileID = P.UserID
	WHERE (RowNumber BETWEEN @RowIndex AND @EndRow)
	ORDER BY RowNumber ASC
END;
') ELSE Exec('
CREATE PROCEDURE {databaseOwner}[{objectQualifier}Journal_ListForSummary]
	@PortalId 			Int,
	@ModuleId 			Int,
	@CurrentUserId 		Int,
	@RowIndex 			Int,
	@MaxRows 			Int,
	@IncludeAllItems 	Int = 0,
	@IsDeleted 			Int = 0	
AS
BEGIN
	IF @RowIndex = 0 SET @RowIndex = 1 -- this is not best practice, IMHO
	
	DECLARE @EndRow Int  = @RowIndex + @MaxRows - 1;
	
	WITH JournalItems AS (
		SELECT JournalId, 
			   ROW_NUMBER() OVER (ORDER BY JournalId DESC) AS RowNumber
		 FROM  {databaseOwner}[{objectQualifier}Journal_PermittedJournalIDs](@PortalId, @CurrentUserId) 
		 WHERE PortalId = @PortalId
		   AND JournalTypeId IN (SELECT JournalTypeId FROM {databaseOwner}[{objectQualifier}Journal_ValidJournalTypesForModule](@ModuleId))		
		   AND (@IncludeAllItems = 1 or isDeleted = @isDeleted)
	) SELECT	
			J.JournalId, 
			J.JournalTypeId, 
			J.Title, 
			J.Summary, 
			J.UserId, 
			J.DateCreated, 
			J.DateUpdated, 
			J.PortalId,
			J.ProfileId, 
			J.GroupId, 
			J.ObjectKey, 
			J.AccessKey,
			{databaseOwner}[{objectQualifier}Journal_XMLEntityNode](J.ProfileId, P.DisplayName) AS JournalOwner,
			{databaseOwner}[{objectQualifier}Journal_XMLEntityNode](J.UserId,    U.DisplayName) AS JournalAuthor,
			IsNull(J.ProfileId, J.UserId) AS JournalOwnerId,
			J.Icon, 
			J.JournalType,
			{databaseOwner}[{objectQualifier}Journal_XMLEntityNode](J.ProfileId, P.DisplayName) AS Profile,
			J.JournalXML, 
			J.ContentItemId, 
			J.ItemData, 
			RowNumber, 
			J.IsDeleted, 
			J.CommentsDisabled, 
			J.CommentsHidden
	FROM	   JournalItems 									 JI
	INNER JOIN {databaseOwner}[{objectQualifier}vw_JournalItems] J  ON J.JournalId = JI.JournalId 
	LEFT  JOIN {databaseOwner}[{objectQualifier}Users]           U  ON J.UserID    = U.UserID
	LEFT  JOIN {databaseOwner}[{objectQualifier}Users]           P  ON J.ProfileID = P.UserID
	WHERE (RowNumber BETWEEN @RowIndex AND @EndRow)
	ORDER BY RowNumber ASC
END;
')
GO



IF {databaseOwner}[{objectQualifier}sys_currentDNNVersion]() >= 70302 EXEC ('
CREATE PROCEDURE {databaseOwner}[{objectQualifier}Journal_ListForProfile]
	@PortalId 		 Int,
	@ModuleId 		 Int,
	@CurrentUserId   Int,
	@ProfileId 		 Int,
	@RowIndex 		 Int,
	@MaxRows 		 Int,
	@IncludeAllItems Int = 0,
	@IsDeleted 		 Int = 0
AS
	DECLARE @EndRow int = @RowIndex + @MaxRows;
			
	WITH JournalItems AS (
		SELECT JournalId, 
			   ROW_NUMBER() OVER (ORDER BY JournalId DESC) AS RowNumber
		 FROM  {databaseOwner}[{objectQualifier}Journal_PermittedJournalIDs](@PortalId, @CurrentUserId) 
		 WHERE PortalId  = @PortalId
		   AND ProfileId = @ProfileId
		   AND JournalTypeId IN (SELECT JournalTypeId FROM {databaseOwner}[{objectQualifier}Journal_ValidJournalTypesForModule](@ModuleId))		
		   AND (@IncludeAllItems = 1 or isDeleted = @isDeleted)
	) SELECT	
			J.JournalId, 
			J.JournalTypeId, 
			J.Title, 
			J.Summary, 
			J.UserId, 
			J.DateCreated, 
			J.DateUpdated, 
			J.PortalId,
			J.ProfileId, 
			J.GroupId, 
			J.ObjectKey, 
			J.AccessKey,
			{databaseOwner}[{objectQualifier}Journal_XMLEntityNode](J.ProfileId, P.DisplayName) AS JournalOwner,
			{databaseOwner}[{objectQualifier}Journal_XMLEntityNode](J.UserId,    U.DisplayName) AS JournalAuthor,
			IsNull(J.ProfileId, J.UserId) AS JournalOwnerId,
			J.Icon, 
			J.JournalType,
			{databaseOwner}[{objectQualifier}Journal_XMLEntityNode](J.ProfileId, P.DisplayName) AS Profile,
			(SELECT COUNT(JournalId) FROM {databaseOwner}[{objectQualifier}Journal] WHERE ContentItemId = j.ContentItemId AND JournalTypeId = j.JournalTypeId) AS SimilarCount,
			J.JournalXML, 
			J.ContentItemId, 
			J.ItemData, RowNumber, 
			J.IsDeleted, 
			J.CommentsDisabled, 
			J.CommentsHidden
	FROM		journalItems                                     JI
	INNER JOIN {databaseOwner}[{objectQualifier}vw_JournalItems] J  ON J.JournalId = JI.JournalId 
	LEFT  JOIN {databaseOwner}[{objectQualifier}Users]           U  ON J.UserID    = U.UserID
	LEFT  JOIN {databaseOwner}[{objectQualifier}Users]           P  ON J.ProfileID = P.UserID
	WHERE (RowNumber BETWEEN @RowIndex AND @EndRow)
	ORDER BY RowNumber ASC;
') ELSE Exec ('
CREATE PROCEDURE {databaseOwner}[{objectQualifier}Journal_ListForProfile]
	@PortalId 		 Int,
	@ModuleId 		 Int,
	@CurrentUserId   Int,
	@ProfileId 		 Int,
	@RowIndex 		 Int,
	@MaxRows 		 Int,
	@IncludeAllItems Int = 0,
	@IsDeleted 		 Int = 0
AS
	DECLARE @EndRow int = @RowIndex + @MaxRows;
			
	WITH JournalItems AS (
		SELECT JournalId, 
			   ROW_NUMBER() OVER (ORDER BY JournalId DESC) AS RowNumber
		 FROM  {databaseOwner}[{objectQualifier}Journal_PermittedJournalIDs](@PortalId, @CurrentUserId) 
		 WHERE PortalId  = @PortalId
		   AND ProfileId = @ProfileId
		   AND JournalTypeId IN (SELECT JournalTypeId FROM {databaseOwner}[{objectQualifier}Journal_ValidJournalTypesForModule](@ModuleId))		
		   AND (@IncludeAllItems = 1 or isDeleted = @isDeleted)
	) SELECT	
			J.JournalId, 
			J.JournalTypeId, 
			J.Title, 
			J.Summary, 
			J.UserId, 
			J.DateCreated, 
			J.DateUpdated, 
			J.PortalId,
			J.ProfileId, 
			J.GroupId, 
			J.ObjectKey, 
			J.AccessKey,
			{databaseOwner}[{objectQualifier}Journal_XMLEntityNode](J.ProfileId, P.DisplayName) AS JournalOwner,
			{databaseOwner}[{objectQualifier}Journal_XMLEntityNode](J.UserId,    U.DisplayName) AS JournalAuthor,
			IsNull(J.ProfileId, J.UserId) AS JournalOwnerId,
			J.Icon, 
			J.JournalType,
			{databaseOwner}[{objectQualifier}Journal_XMLEntityNode](J.ProfileId, P.DisplayName) AS Profile,
			J.JournalXML, 
			J.ContentItemId, 
			J.ItemData, RowNumber, 
			J.IsDeleted, 
			J.CommentsDisabled, 
			J.CommentsHidden
	FROM		journalItems                                     JI
	INNER JOIN {databaseOwner}[{objectQualifier}vw_JournalItems] J  ON J.JournalId = JI.JournalId 
	LEFT  JOIN {databaseOwner}[{objectQualifier}Users]           U  ON J.UserID    = U.UserID
	LEFT  JOIN {databaseOwner}[{objectQualifier}Users]           P  ON J.ProfileID = P.UserID
	WHERE (RowNumber BETWEEN @RowIndex AND @EndRow)
	ORDER BY RowNumber ASC;
')
GO



CREATE PROCEDURE {databaseOwner}[{objectQualifier}Journal_Comment_List]
	@JournalId Int -- Not Null
AS
BEGIN
	SELECT * 
	 FROM {databaseOwner}[{objectQualifier}vw_JournalComments] 
	 WHERE JournalId = @JournalId
	 ORDER BY [JournalID], [DateCreated]
END
GO


CREATE PROCEDURE {databaseOwner}[{objectQualifier}Journal_Comment_ListByJournalIds]
	@JournalIdList 	nVarChar(max) = '' -- Not Null
AS
BEGIN
	SELECT C.* 
	FROM       {databaseOwner}[{objectQualifier}vw_JournalComments] AS C  
	INNER JOIN {databaseOwner}[{objectQualifier}Journal_Split](@JournalIdList, ';') AS J ON J.Id = C.JournalId
	ORDER BY C.CommentId ASC
END
GO

CREATE PROCEDURE {databaseOwner}[{objectQualifier}Journal_Comment_Get]
	@CommentId Int -- not Null
AS
BEGIN
	SELECT * 
	FROM {databaseOwner}[{objectQualifier}vw_JournalComments] 
	WHERE CommentId = @CommentId
END
GO


CREATE PROCEDURE {databaseOwner}[{objectQualifier}Journal_TypeFilters_List]
	@PortalId int, -- null|-1: all
	@ModuleId int  -- null|-1: all
AS
BEGIN
	SELECT JournalTypeId, 
		   JournalType 
	 FROM  {databaseOwner}[{objectQualifier}vw_JournalTypeFilters] 
	 WHERE (IsNull(PortalId, -1) = -1 OR PortalId = @PortalId)
	   AND (IsNull(ModuleId, -1) = -1 OR ModuleId = @ModuleId)
END
GO


IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'{databaseOwner}[{objectQualifier}SavePackageDependency]') AND type in (N'P', N'PC'))
    DROP PROCEDURE {databaseOwner}[{objectQualifier}SavePackageDependency]
GO

IF {databaseOwner}[{objectQualifier}sys_currentDNNVersion]() >= 70200 EXEC ('
CREATE PROCEDURE {databaseOwner}[{objectQualifier}SavePackageDependency]
	@PackageDependencyID Int,
	@PackageID 			 Int,
	@PackageName 		 nVarChar(128),
	@Version 			 nVarChar(10)
AS 
BEGIN
	SET NOCOUNT ON;
	IF EXISTS (SELECT * FROM {databaseOwner}[{objectQualifier}PackageDependencies] 
	            WHERE [PackageDependencyID] = @PackageDependencyID)
		UPDATE {databaseOwner}[{objectQualifier}PackageDependencies]
		 SET   [PackageID]	  = @PackageID,
			   [PackageName]  = @PackageName,
			   [Version] 	  = @Version
		 WHERE [PackageDependencyID] = @PackageDependencyID
	ELSE IF EXISTS (SELECT * FROM {databaseOwner}[{objectQualifier}PackageDependencies]
	                WHERE [PackageID] = @PackageID AND [PackageName] = @PackageName)
		 -- fetch PackageDependencyID:
		 SELECT @PackageDependencyID = [PackageDependencyID] 
		  FROM  {databaseOwner}[{objectQualifier}PackageDependencies]
		  WHERE [PackageID] = @PackageID AND [PackageName] = @PackageName
	ELSE BEGIN
			INSERT INTO {databaseOwner}[{objectQualifier}PackageDependencies] 
			(   [PackageID],
				[PackageName],
				[Version]
			) VALUES 
			(   @PackageID,
				@PackageName,
				@Version
			)
		SELECT @PackageDependencyID = SCOPE_IDENTITY()
	END;
	SELECT @PackageDependencyID;
	SET NOCOUNT OFF;
END
')
GO
